"""
Copyright &copy; 2024 NetApp Inc. All rights reserved.

All of the modules in this package define the supporting objects used to
organize the fields in the corresponding `netapp_ontap.resource.Resource`
types. These models are a subset of `netapp_ontap.resource.Resource` and
do not have any actions that can be performed on them.
"""

# pylint: disable=trailing-newlines
# pylint: disable=line-too-long
# pylint: disable=too-many-lines

from netapp_ontap.models.storage_switch_fans import StorageSwitchFans
from netapp_ontap.models.auto_update_info_eula import AutoUpdateInfoEula
from netapp_ontap.models.storage_switch_connections import StorageSwitchConnections
from netapp_ontap.models.volume_space import VolumeSpace
from netapp_ontap.models.azure_key_vault_connectivity import AzureKeyVaultConnectivity
from netapp_ontap.models.ems_filter_rule_response_records_parameter_criteria import EmsFilterRuleResponseRecordsParameterCriteria
from netapp_ontap.models.top_metrics_directory_response_incomplete_response_reason import TopMetricsDirectoryResponseIncompleteResponseReason
from netapp_ontap.models.software_validation_reference_issue import SoftwareValidationReferenceIssue
from netapp_ontap.models.nfs_service_protocol import NfsServiceProtocol
from netapp_ontap.models.cluster_space_block_storage_medias import ClusterSpaceBlockStorageMedias
from netapp_ontap.models.consistency_group_lun_map import ConsistencyGroupLunMap
from netapp_ontap.models.snapmirror_policy_rule import SnapmirrorPolicyRule
from netapp_ontap.models.application_statistics_iops import ApplicationStatisticsIops
from netapp_ontap.models.performance_nvme_metric_properties import PerformanceNvmeMetricProperties
from netapp_ontap.models.fc_port_speed import FcPortSpeed
from netapp_ontap.models.zapp_nvme_components_performance import ZappNvmeComponentsPerformance
from netapp_ontap.models.vsi_on_nas import VsiOnNas
from netapp_ontap.models.svm_migration_destination_volume_placement_aggregates import SvmMigrationDestinationVolumePlacementAggregates
from netapp_ontap.models.cifs_open_file_session import CifsOpenFileSession
from netapp_ontap.models.acl_delete import AclDelete
from netapp_ontap.models.disk_aggregates import DiskAggregates
from netapp_ontap.models.ems_event_links import EmsEventLinks
from netapp_ontap.models.file_move_scanner import FileMoveScanner
from netapp_ontap.models.vsi_on_nas_datastore_storage_service import VsiOnNasDatastoreStorageService
from netapp_ontap.models.consistency_group_response_records_consistency_groups_luns import ConsistencyGroupResponseRecordsConsistencyGroupsLuns
from netapp_ontap.models.volume_efficiency import VolumeEfficiency
from netapp_ontap.models.lun_status import LunStatus
from netapp_ontap.models.nvme_subsystem_host_records_subsystem import NvmeSubsystemHostRecordsSubsystem
from netapp_ontap.models.version import Version
from netapp_ontap.models.active_directory_preferred_dcs import ActiveDirectoryPreferredDcs
from netapp_ontap.models.capacity_pool_response_records_nodes import CapacityPoolResponseRecordsNodes
from netapp_ontap.models.ad_domain_delete import AdDomainDelete
from netapp_ontap.models.kerberos_realm_password_server import KerberosRealmPasswordServer
from netapp_ontap.models.key_server_state import KeyServerState
from netapp_ontap.models.igroup_initiators_proximity_peer_svms import IgroupInitiatorsProximityPeerSvms
from netapp_ontap.models.svm_nis import SvmNis
from netapp_ontap.models.capacity_pool_node import CapacityPoolNode
from netapp_ontap.models.cluster_nodes_controller import ClusterNodesController
from netapp_ontap.models.cluster_nodes_ha_giveback_status import ClusterNodesHaGivebackStatus
from netapp_ontap.models.firmware_history_update_state_error import FirmwareHistoryUpdateStateError
from netapp_ontap.models.nas_exclude_aggregates import NasExcludeAggregates
from netapp_ontap.models.nvme_interface_fc_interface import NvmeInterfaceFcInterface
from netapp_ontap.models.firmware_disk import FirmwareDisk
from netapp_ontap.models.oracle_rac_on_san_new_igroups import OracleRacOnSanNewIgroups
from netapp_ontap.models.nvme_namespace_space_guarantee import NvmeNamespaceSpaceGuarantee
from netapp_ontap.models.portset_interface_no_records import PortsetInterfaceNoRecords
from netapp_ontap.models.igroup_nested_no_records import IgroupNestedNoRecords
from netapp_ontap.models.interface_metrics_data import InterfaceMetricsData
from netapp_ontap.models.oracle_on_nfs_ora_home import OracleOnNfsOraHome
from netapp_ontap.models.application_links import ApplicationLinks
from netapp_ontap.models.storage_switch_ports import StorageSwitchPorts
from netapp_ontap.models.consistency_group_response_records_consistency_groups_volumes import ConsistencyGroupResponseRecordsConsistencyGroupsVolumes
from netapp_ontap.models.firmware_dqp_record_count import FirmwareDqpRecordCount
from netapp_ontap.models.igroup_replication import IgroupReplication
from netapp_ontap.models.lun_lun_maps import LunLunMaps
from netapp_ontap.models.consistency_group_application import ConsistencyGroupApplication
from netapp_ontap.models.disk_error_info import DiskErrorInfo
from netapp_ontap.models.fabric_connections_cluster_port import FabricConnectionsClusterPort
from netapp_ontap.models.storage_bridge_sas_ports_cable import StorageBridgeSasPortsCable
from netapp_ontap.models.application_nfs_properties_permissions import ApplicationNfsPropertiesPermissions
from netapp_ontap.models.iscsi_connection_interface import IscsiConnectionInterface
from netapp_ontap.models.ekmip_server_connectivity import EkmipServerConnectivity
from netapp_ontap.models.nvme_subsystem_controller_digest import NvmeSubsystemControllerDigest
from netapp_ontap.models.consistency_group_lun_lun_maps_igroup_igroups import ConsistencyGroupLunLunMapsIgroupIgroups
from netapp_ontap.models.node_setup_ip import NodeSetupIp
from netapp_ontap.models.igroup_nested_igroup import IgroupNestedIgroup
from netapp_ontap.models.oracle_on_nfs_redo_log_storage_service import OracleOnNfsRedoLogStorageService
from netapp_ontap.models.consistency_group_replication_relationships1 import ConsistencyGroupReplicationRelationships1
from netapp_ontap.models.kerberos_realm_admin_server import KerberosRealmAdminServer
from netapp_ontap.models.nvme_subsystem_host_records_io_queue import NvmeSubsystemHostRecordsIoQueue
from netapp_ontap.models.consistency_group_luns import ConsistencyGroupLuns
from netapp_ontap.models.consistency_group_luns_lun_maps_igroup_initiators import ConsistencyGroupLunsLunMapsIgroupInitiators
from netapp_ontap.models.iscsi_connection_interface_ip import IscsiConnectionInterfaceIp
from netapp_ontap.models.active_directory_delete import ActiveDirectoryDelete
from netapp_ontap.models.local_cifs_user_membership import LocalCifsUserMembership
from netapp_ontap.models.storage_switch_zones_port import StorageSwitchZonesPort
from netapp_ontap.models.software_images_inner import SoftwareImagesInner
from netapp_ontap.models.fcp_service_target import FcpServiceTarget
from netapp_ontap.models.nvme_namespace_subsystem_map import NvmeNamespaceSubsystemMap
from netapp_ontap.models.ems_action_parameter import EmsActionParameter
from netapp_ontap.models.plex_resync import PlexResync
from netapp_ontap.models.top_metrics_file_iops import TopMetricsFileIops
from netapp_ontap.models.acl import Acl
from netapp_ontap.models.lun_space_guarantee import LunSpaceGuarantee
from netapp_ontap.models.cluster_nodes_service_processor_auto_config import ClusterNodesServiceProcessorAutoConfig
from netapp_ontap.models.svm_nfs import SvmNfs
from netapp_ontap.models.top_metrics_client_iops import TopMetricsClientIops
from netapp_ontap.models.timezone_cluster import TimezoneCluster
from netapp_ontap.models.license_capacity import LicenseCapacity
from netapp_ontap.models.storage_switch_errors import StorageSwitchErrors
from netapp_ontap.models.consistency_group_response_records_consistency_groups_namespaces import ConsistencyGroupResponseRecordsConsistencyGroupsNamespaces
from netapp_ontap.models.s3_bucket_policy import S3BucketPolicy
from netapp_ontap.models.returned_error import ReturnedError
from netapp_ontap.models.consistency_group_namespace_status import ConsistencyGroupNamespaceStatus
from netapp_ontap.models.mongo_db_on_san_protection_type import MongoDbOnSanProtectionType
from netapp_ontap.models.application_statistics import ApplicationStatistics
from netapp_ontap.models.consistency_group_child_luns_lun_maps import ConsistencyGroupChildLunsLunMaps
from netapp_ontap.models.qtree_nas import QtreeNas
from netapp_ontap.models.volume_consistency_group import VolumeConsistencyGroup
from netapp_ontap.models.cloud_storage_tier import CloudStorageTier
from netapp_ontap.models.cluster_nodes_vm import ClusterNodesVm
from netapp_ontap.models.switch_port_remote_port_device import SwitchPortRemotePortDevice
from netapp_ontap.models.cifs_domain_discovered_server import CifsDomainDiscoveredServer
from netapp_ontap.models.metrocluster_local import MetroclusterLocal
from netapp_ontap.models.cluster_peer_links import ClusterPeerLinks
from netapp_ontap.models.disk_stats import DiskStats
from netapp_ontap.models.anti_ransomware_volume_space import AntiRansomwareVolumeSpace
from netapp_ontap.models.ems_action_parameter_description_arguments import EmsActionParameterDescriptionArguments
from netapp_ontap.models.hw_assist_status import HwAssistStatus
from netapp_ontap.models.quota_report_space_used import QuotaReportSpaceUsed
from netapp_ontap.models.zapp_nvme_rpo_local import ZappNvmeRpoLocal
from netapp_ontap.models.ndmp_scsi import NdmpScsi
from netapp_ontap.models.firmware_shelf import FirmwareShelf
from netapp_ontap.models.disk_key_id import DiskKeyId
from netapp_ontap.models.ipv4_interface_and_gateway import Ipv4InterfaceAndGateway
from netapp_ontap.models.license_manager_response_records import LicenseManagerResponseRecords
from netapp_ontap.models.consistency_group_qos import ConsistencyGroupQos
from netapp_ontap.models.ems_event_response_records_parameters import EmsEventResponseRecordsParameters
from netapp_ontap.models.consistency_group_volume_provisioning_options import ConsistencyGroupVolumeProvisioningOptions
from netapp_ontap.models.software_status_details import SoftwareStatusDetails
from netapp_ontap.models.application_san_access_iscsi_endpoint import ApplicationSanAccessIscsiEndpoint
from netapp_ontap.models.s3_bucket_svm_aggregates import S3BucketSvmAggregates
from netapp_ontap.models.node_response_records_ha_giveback_status import NodeResponseRecordsHaGivebackStatus
from netapp_ontap.models.application_component_snapshot_component import ApplicationComponentSnapshotComponent
from netapp_ontap.models.schedule_cluster import ScheduleCluster
from netapp_ontap.models.consistency_group_namespace import ConsistencyGroupNamespace
from netapp_ontap.models.vscan_on_demand_policy import VscanOnDemandPolicy
from netapp_ontap.models.mongo_db_on_san_new_igroups_igroups import MongoDbOnSanNewIgroupsIgroups
from netapp_ontap.models.storage_bridge_paths_target_port import StorageBridgePathsTargetPort
from netapp_ontap.models.consistency_group_consistency_groups_restore_to import ConsistencyGroupConsistencyGroupsRestoreTo
from netapp_ontap.models.application_rpo_remote import ApplicationRpoRemote
from netapp_ontap.models.application_snapshot_components import ApplicationSnapshotComponents
from netapp_ontap.models.oracle_rac_on_san_db_sids import OracleRacOnSanDbSids
from netapp_ontap.models.application_cifs_properties_share import ApplicationCifsPropertiesShare
from netapp_ontap.models.application_cifs_properties_permissions import ApplicationCifsPropertiesPermissions
from netapp_ontap.models.license_compliance import LicenseCompliance
from netapp_ontap.models.backup_node import BackupNode
from netapp_ontap.models.consistency_group_response_records_namespaces import ConsistencyGroupResponseRecordsNamespaces
from netapp_ontap.models.nvme_subsystem_subsystem_maps import NvmeSubsystemSubsystemMaps
from netapp_ontap.models.shelf_voltage_sensors import ShelfVoltageSensors
from netapp_ontap.models.key_server_readcreate import KeyServerReadcreate
from netapp_ontap.models.metrocluster_interconnect_interfaces import MetroclusterInterconnectInterfaces
from netapp_ontap.models.volume_metrics_response_records import VolumeMetricsResponseRecords
from netapp_ontap.models.s3_bucket_svm_protection_status import S3BucketSvmProtectionStatus
from netapp_ontap.models.tls import Tls
from netapp_ontap.models.application_statistics_components_iops import ApplicationStatisticsComponentsIops
from netapp_ontap.models.node_response_records_ha_giveback import NodeResponseRecordsHaGiveback
from netapp_ontap.models.vdi_on_nas import VdiOnNas
from netapp_ontap.models.volume_nas import VolumeNas
from netapp_ontap.models.nvme_service_metric import NvmeServiceMetric
from netapp_ontap.models.security_certificate_ref_uuid import SecurityCertificateRefUuid
from netapp_ontap.models.svm_fcp import SvmFcp
from netapp_ontap.models.ems_role_config_response_records import EmsRoleConfigResponseRecords
from netapp_ontap.models.multi_admin_verify_rule_approval_groups import MultiAdminVerifyRuleApprovalGroups
from netapp_ontap.models.quota_report_group import QuotaReportGroup
from netapp_ontap.models.security_audit_log_svm import SecurityAuditLogSvm
from netapp_ontap.models.file_move_files_to_move import FileMoveFilesToMove
from netapp_ontap.models.application_lun_mapping_object import ApplicationLunMappingObject
from netapp_ontap.models.svm_migration_volume_placement_aggregates import SvmMigrationVolumePlacementAggregates
from netapp_ontap.models.nas import Nas
from netapp_ontap.models.cluster_nodes_controller_cpu import ClusterNodesControllerCpu
from netapp_ontap.models.s3_bucket_policy_statement import S3BucketPolicyStatement
from netapp_ontap.models.cifs_domain_name_mapping import CifsDomainNameMapping
from netapp_ontap.models.application_volume_object import ApplicationVolumeObject
from netapp_ontap.models.fpolicy_event_filters import FpolicyEventFilters
from netapp_ontap.models.volume_efficiency_idcs_scanner import VolumeEfficiencyIdcsScanner
from netapp_ontap.models.nfs_service_windows import NfsServiceWindows
from netapp_ontap.models.ems_event_action_parameters_description_arguments import EmsEventActionParametersDescriptionArguments
from netapp_ontap.models.volume_space_snapshot import VolumeSpaceSnapshot
from netapp_ontap.models.anti_ransomware_suspect_file import AntiRansomwareSuspectFile
from netapp_ontap.models.performance_metric_io_type_rwt import PerformanceMetricIoTypeRwt
from netapp_ontap.models.chassis_nodes import ChassisNodes
from netapp_ontap.models.performance_fc_port_metric_response_records import PerformanceFcPortMetricResponseRecords
from netapp_ontap.models.svm_ndmp import SvmNdmp
from netapp_ontap.models.shelf_temperature_sensors_threshold_low import ShelfTemperatureSensorsThresholdLow
from netapp_ontap.models.sql_on_smb import SqlOnSmb
from netapp_ontap.models.cifs_domain_preferred_dcs import CifsDomainPreferredDcs
from netapp_ontap.models.aggregate_block_storage_mirror import AggregateBlockStorageMirror
from netapp_ontap.models.cluster_nodes_cluster_interfaces import ClusterNodesClusterInterfaces
from netapp_ontap.models.s3_policy_statement import S3PolicyStatement
from netapp_ontap.models.audit_schedule import AuditSchedule
from netapp_ontap.models.svm_migration_time_metrics import SvmMigrationTimeMetrics
from netapp_ontap.models.fabric_cache import FabricCache
from netapp_ontap.models.account_application import AccountApplication
from netapp_ontap.models.application_nvme_access_subsystem_map_subsystem_hosts_links import ApplicationNvmeAccessSubsystemMapSubsystemHostsLinks
from netapp_ontap.models.peer import Peer
from netapp_ontap.models.mongo_db_on_san_new_igroups import MongoDbOnSanNewIgroups
from netapp_ontap.models.s3_bucket_lifecycle_management_rules import S3BucketLifecycleManagementRules
from netapp_ontap.models.share import Share
from netapp_ontap.models.key_server_no_records import KeyServerNoRecords
from netapp_ontap.models.qos_policy_adaptive import QosPolicyAdaptive
from netapp_ontap.models.hw_assist import HwAssist
from netapp_ontap.models.windows_to_unix import WindowsToUnix
from netapp_ontap.models.aggregate_simulate import AggregateSimulate
from netapp_ontap.models.nfs_service_credential_cache import NfsServiceCredentialCache
from netapp_ontap.models.node_ha_partners import NodeHaPartners
from netapp_ontap.models.top_metrics_svm_client_excluded_volume_reason import TopMetricsSvmClientExcludedVolumeReason
from netapp_ontap.models.firmware_dqp import FirmwareDqp
from netapp_ontap.models.snapmirror_consistency_group_failover_status import SnapmirrorConsistencyGroupFailoverStatus
from netapp_ontap.models.storage_bridge_fc_ports import StorageBridgeFcPorts
from netapp_ontap.models.tape_device_storage_port import TapeDeviceStoragePort
from netapp_ontap.models.counter_property import CounterProperty
from netapp_ontap.models.cifs_connection_sessions import CifsConnectionSessions
from netapp_ontap.models.consistency_group_response_records_volumes import ConsistencyGroupResponseRecordsVolumes
from netapp_ontap.models.node_statistics import NodeStatistics
from netapp_ontap.models.s3_bucket_encryption import S3BucketEncryption
from netapp_ontap.models.top_metrics_directory_response_notice import TopMetricsDirectoryResponseNotice
from netapp_ontap.models.metrocluster_diagnostics_interface import MetroclusterDiagnosticsInterface
from netapp_ontap.models.capacity_pool_response_records import CapacityPoolResponseRecords
from netapp_ontap.models.snapmirror_error import SnapmirrorError
from netapp_ontap.models.application_rpo_local import ApplicationRpoLocal
from netapp_ontap.models.consistency_group_space import ConsistencyGroupSpace
from netapp_ontap.models.fc_zone_members import FcZoneMembers
from netapp_ontap.models.interface_metrics_response_records import InterfaceMetricsResponseRecords
from netapp_ontap.models.consistency_group_export_policy import ConsistencyGroupExportPolicy
from netapp_ontap.models.flexcache_writeback import FlexcacheWriteback
from netapp_ontap.models.quota_rule_group import QuotaRuleGroup
from netapp_ontap.models.volume_protocol_raw_performance_stat_rw import VolumeProtocolRawPerformanceStatRw
from netapp_ontap.models.aws_kms_ekmip_reachability import AwsKmsEkmipReachability
from netapp_ontap.models.lun_map_lun import LunMapLun
from netapp_ontap.models.application_san_access_backing_storage import ApplicationSanAccessBackingStorage
from netapp_ontap.models.share_acl import ShareAcl
from netapp_ontap.models.cluster_nodes_controller_flash_cache import ClusterNodesControllerFlashCache
from netapp_ontap.models.lun_movement import LunMovement
from netapp_ontap.models.sql_on_smb_access import SqlOnSmbAccess
from netapp_ontap.models.ems_event_update import EmsEventUpdate
from netapp_ontap.models.qos_policy_fixed import QosPolicyFixed
from netapp_ontap.models.lun_map_reporting_nodes_links import LunMapReportingNodesLinks
from netapp_ontap.models.shelf_temperature_sensors_threshold import ShelfTemperatureSensorsThreshold
from netapp_ontap.models.consistency_group_luns_lun_maps_igroup_igroups import ConsistencyGroupLunsLunMapsIgroupIgroups
from netapp_ontap.models.cluster_nodes_controller_failed_fan_message import ClusterNodesControllerFailedFanMessage
from netapp_ontap.models.fpolicy_connection_disconnected_reason import FpolicyConnectionDisconnectedReason
from netapp_ontap.models.instance_counter_aggregation import InstanceCounterAggregation
from netapp_ontap.models.performance_svm_nfs_metric import PerformanceSvmNfsMetric
from netapp_ontap.models.ems_destination_response_records_connectivity_errors_message_arguments import EmsDestinationResponseRecordsConnectivityErrorsMessageArguments
from netapp_ontap.models.fabric_connections_cluster_port_node import FabricConnectionsClusterPortNode
from netapp_ontap.models.mongo_db_on_san_dataset_storage_service import MongoDbOnSanDatasetStorageService
from netapp_ontap.models.vsi_on_nas_datastore import VsiOnNasDatastore
from netapp_ontap.models.ip_interface_svm import IpInterfaceSvm
from netapp_ontap.models.ems_event_action_parameters_title_arguments import EmsEventActionParametersTitleArguments
from netapp_ontap.models.storage_switch_paths import StorageSwitchPaths
from netapp_ontap.models.nis_service_binding_details import NisServiceBindingDetails
from netapp_ontap.models.svm_migration_ip_interface_placement import SvmMigrationIpInterfacePlacement
from netapp_ontap.models.storage_pool_spare_allocation_unit import StoragePoolSpareAllocationUnit
from netapp_ontap.models.scanner_pool import ScannerPool
from netapp_ontap.models.application_protection_groups_rpo_remote import ApplicationProtectionGroupsRpoRemote
from netapp_ontap.models.volume_protocol_raw_performance_stats import VolumeProtocolRawPerformanceStats
from netapp_ontap.models.performance_metric_reduced_throughput import PerformanceMetricReducedThroughput
from netapp_ontap.models.application_statistics_components import ApplicationStatisticsComponents
from netapp_ontap.models.ndmp_data import NdmpData
from netapp_ontap.models.igroup_initiator_list_item_proximity import IgroupInitiatorListItemProximity
from netapp_ontap.models.anti_ransomware_volume import AntiRansomwareVolume
from netapp_ontap.models.svm_aggregates import SvmAggregates
from netapp_ontap.models.ems_event_action_description_arguments import EmsEventActionDescriptionArguments
from netapp_ontap.models.ad_domain_svm import AdDomainSvm
from netapp_ontap.models.aggregate_snapshot import AggregateSnapshot
from netapp_ontap.models.performance_monitored_files_metric import PerformanceMonitoredFilesMetric
from netapp_ontap.models.application_component_application import ApplicationComponentApplication
from netapp_ontap.models.oracle_rac_on_nfs import OracleRacOnNfs
from netapp_ontap.models.volume_activity_tracking_unsupported_reason import VolumeActivityTrackingUnsupportedReason
from netapp_ontap.models.counter_denominator import CounterDenominator
from netapp_ontap.models.security_association_response_records import SecurityAssociationResponseRecords
from netapp_ontap.models.quota_rule_users import QuotaRuleUsers
from netapp_ontap.models.consistency_group_qos_policy import ConsistencyGroupQosPolicy
from netapp_ontap.models.ems_filter_response_records import EmsFilterResponseRecords
from netapp_ontap.models.gcp_kms_key import GcpKmsKey
from netapp_ontap.models.volume_rebalancing1_engine_movement import VolumeRebalancing1EngineMovement
from netapp_ontap.models.consistency_group_namespace_space_guarantee import ConsistencyGroupNamespaceSpaceGuarantee
from netapp_ontap.models.export_rules import ExportRules
from netapp_ontap.models.fpolicy_engine_svm import FpolicyEngineSvm
from netapp_ontap.models.consistency_group_volumes import ConsistencyGroupVolumes
from netapp_ontap.models.volume_asynchronous_directory_delete import VolumeAsynchronousDirectoryDelete
from netapp_ontap.models.aggregate_space import AggregateSpace
from netapp_ontap.models.snapshot_snaplock import SnapshotSnaplock
from netapp_ontap.models.top_metrics_svm_file_excluded_volume import TopMetricsSvmFileExcludedVolume
from netapp_ontap.models.snapshot_policy_copies import SnapshotPolicyCopies
from netapp_ontap.models.nvme_namespace_status import NvmeNamespaceStatus
from netapp_ontap.models.unix_group_users_no_records import UnixGroupUsersNoRecords
from netapp_ontap.models.volume_space_logical_space import VolumeSpaceLogicalSpace
from netapp_ontap.models.consistency_group_volume import ConsistencyGroupVolume
from netapp_ontap.models.igroup_initiator_list_item_proximity_peer_svms import IgroupInitiatorListItemProximityPeerSvms
from netapp_ontap.models.application_nvme_access_subsystem_map_subsystem import ApplicationNvmeAccessSubsystemMapSubsystem
from netapp_ontap.models.snapmirror_consistency_group_failover import SnapmirrorConsistencyGroupFailover
from netapp_ontap.models.nvme_subsystem_controller_host import NvmeSubsystemControllerHost
from netapp_ontap.models.top_metrics_client_throughput import TopMetricsClientThroughput
from netapp_ontap.models.ems_event_action_parameters import EmsEventActionParameters
from netapp_ontap.models.group_policy_object_security_setting import GroupPolicyObjectSecuritySetting
from netapp_ontap.models.chassis_nodes_usbs_ports import ChassisNodesUsbsPorts
from netapp_ontap.models.iscsi_connection import IscsiConnection
from netapp_ontap.models.ems_destination_response_records import EmsDestinationResponseRecords
from netapp_ontap.models.multi_admin_verify_rule_owner import MultiAdminVerifyRuleOwner
from netapp_ontap.models.quota_rule_qtree import QuotaRuleQtree
from netapp_ontap.models.s3_bucket_lifecycle_expiration import S3BucketLifecycleExpiration
from netapp_ontap.models.iscsi_credentials_initiator_address import IscsiCredentialsInitiatorAddress
from netapp_ontap.models.lun_space import LunSpace
from netapp_ontap.models.snapmirror_transfer_files import SnapmirrorTransferFiles
from netapp_ontap.models.nis import Nis
from netapp_ontap.models.performance_reduced_throughput_response_records import PerformanceReducedThroughputResponseRecords
from netapp_ontap.models.fc_interface_location import FcInterfaceLocation
from netapp_ontap.models.mongo_db_on_san import MongoDbOnSan
from netapp_ontap.models.nvme_namespace_location import NvmeNamespaceLocation
from netapp_ontap.models.shelf_temperature_sensors import ShelfTemperatureSensors
from netapp_ontap.models.group_policy_object_restrict_anonymous import GroupPolicyObjectRestrictAnonymous
from netapp_ontap.models.performance_s3_metric_response_records import PerformanceS3MetricResponseRecords
from netapp_ontap.models.storage_bridge_sas_ports import StorageBridgeSasPorts
from netapp_ontap.models.consistency_group_response_records_luns_lun_maps import ConsistencyGroupResponseRecordsLunsLunMaps
from netapp_ontap.models.export_clients import ExportClients
from netapp_ontap.models.software_node import SoftwareNode
from netapp_ontap.models.error_responses import ErrorResponses
from netapp_ontap.models.storage_bridge_errors import StorageBridgeErrors
from netapp_ontap.models.ems_event_parameter import EmsEventParameter
from netapp_ontap.models.ems_destination_connectivity_errors import EmsDestinationConnectivityErrors
from netapp_ontap.models.quota_report_files_used import QuotaReportFilesUsed
from netapp_ontap.models.fc_interface_recommend_message import FcInterfaceRecommendMessage
from netapp_ontap.models.raid_group_recomputing_parity import RaidGroupRecomputingParity
from netapp_ontap.models.anti_ransomware_attack_report_links import AntiRansomwareAttackReportLinks
from netapp_ontap.models.nas_protection_type import NasProtectionType
from netapp_ontap.models.space_efficiency import SpaceEfficiency
from netapp_ontap.models.self_link import SelfLink
from netapp_ontap.models.ems_action_parameter_validation_error_message_arguments import EmsActionParameterValidationErrorMessageArguments
from netapp_ontap.models.ems_ui_message import EmsUiMessage
from netapp_ontap.models.igroup_initiator_list_item import IgroupInitiatorListItem
from netapp_ontap.models.export_client_policy import ExportClientPolicy
from netapp_ontap.models.cluster_management_interfaces import ClusterManagementInterfaces
from netapp_ontap.models.performance_metric_svm import PerformanceMetricSvm
from netapp_ontap.models.iscsi_credentials_chap import IscsiCredentialsChap
from netapp_ontap.models.performance_lun_metric_response_records import PerformanceLunMetricResponseRecords
from netapp_ontap.models.metrocluster_diagnostics_node import MetroclusterDiagnosticsNode
from netapp_ontap.models.node_ha import NodeHa
from netapp_ontap.models.nas_application_components_qos_policy import NasApplicationComponentsQosPolicy
from netapp_ontap.models.zapp_s3_bucket import ZappS3Bucket
from netapp_ontap.models.anti_ransomware_volume_workload_surge_usage_newly_observed_file_extensions import AntiRansomwareVolumeWorkloadSurgeUsageNewlyObservedFileExtensions
from netapp_ontap.models.snapmirror_relationship_transfer import SnapmirrorRelationshipTransfer
from netapp_ontap.models.consistency_group_namespaces import ConsistencyGroupNamespaces
from netapp_ontap.models.igroup_connectivity_tracking_alerts import IgroupConnectivityTrackingAlerts
from netapp_ontap.models.sql_on_san import SqlOnSan
from netapp_ontap.models.nvme_subsystem_controller_admin_queue import NvmeSubsystemControllerAdminQueue
from netapp_ontap.models.consistency_group_initiator import ConsistencyGroupInitiator
from netapp_ontap.models.consistency_group_child_luns_lun_maps_igroup_initiators import ConsistencyGroupChildLunsLunMapsIgroupInitiators
from netapp_ontap.models.cifs_domain_trust_relationships import CifsDomainTrustRelationships
from netapp_ontap.models.lun_map_reporting_node_igroup import LunMapReportingNodeIgroup
from netapp_ontap.models.ddns import Ddns
from netapp_ontap.models.performance_nvme_metric_response_records import PerformanceNvmeMetricResponseRecords
from netapp_ontap.models.consistency_group_consistency_groups_application import ConsistencyGroupConsistencyGroupsApplication
from netapp_ontap.models.application_protection_groups_rpo import ApplicationProtectionGroupsRpo
from netapp_ontap.models.node_response_records_ha import NodeResponseRecordsHa
from netapp_ontap.models.consistency_group_consistency_groups import ConsistencyGroupConsistencyGroups
from netapp_ontap.models.zapp_s3_bucket_application_components_access_policies import ZappS3BucketApplicationComponentsAccessPolicies
from netapp_ontap.models.performance_metric_io_type import PerformanceMetricIoType
from netapp_ontap.models.lun_lun_maps_igroup import LunLunMapsIgroup
from netapp_ontap.models.top_metrics_svm_directory_response_notice import TopMetricsSvmDirectoryResponseNotice
from netapp_ontap.models.application_component_snapshot_restore_application import ApplicationComponentSnapshotRestoreApplication
from netapp_ontap.models.file_info_links import FileInfoLinks
from netapp_ontap.models.igroup_initiator_no_records import IgroupInitiatorNoRecords
from netapp_ontap.models.port_discovered_devices import PortDiscoveredDevices
from netapp_ontap.models.consistency_group_consistency_groups_tiering_object_stores import ConsistencyGroupConsistencyGroupsTieringObjectStores
from netapp_ontap.models.quota_report_users import QuotaReportUsers
from netapp_ontap.models.top_metrics_svm_user_volumes import TopMetricsSvmUserVolumes
from netapp_ontap.models.raid_group_reconstruct import RaidGroupReconstruct
from netapp_ontap.models.cifs_share_acls import CifsShareAcls
from netapp_ontap.models.volume_metric_cloud import VolumeMetricCloud
from netapp_ontap.models.nas_application_components_export_policy import NasApplicationComponentsExportPolicy
from netapp_ontap.models.iscsi_session_igroups import IscsiSessionIgroups
from netapp_ontap.models.application_snapshot_restore_application import ApplicationSnapshotRestoreApplication
from netapp_ontap.models.zapp_nvme_rpo_remote import ZappNvmeRpoRemote
from netapp_ontap.models.nfs_service_protocol_v3_features import NfsServiceProtocolV3Features
from netapp_ontap.models.zapp_nvme_rpo import ZappNvmeRpo
from netapp_ontap.models.key_server_records import KeyServerRecords
from netapp_ontap.models.application_nvme_access_subsystem_map_subsystem_hosts import ApplicationNvmeAccessSubsystemMapSubsystemHosts
from netapp_ontap.models.volume_quota import VolumeQuota
from netapp_ontap.models.aggregate_warning_warning import AggregateWarningWarning
from netapp_ontap.models.aws_connectivity import AwsConnectivity
from netapp_ontap.models.application_backing_storage import ApplicationBackingStorage
from netapp_ontap.models.mccip_port import MccipPort
from netapp_ontap.models.ndmp_connect import NdmpConnect
from netapp_ontap.models.cifs_domain_discovered_servers import CifsDomainDiscoveredServers
from netapp_ontap.models.metrocluster_svm_partner_svm import MetroclusterSvmPartnerSvm
from netapp_ontap.models.nvme_namespace_space import NvmeNamespaceSpace
from netapp_ontap.models.volume_constituents_aggregates import VolumeConstituentsAggregates
from netapp_ontap.models.volume_constituents_space_snapshot import VolumeConstituentsSpaceSnapshot
from netapp_ontap.models.ems_connectivity_error_message_arguments import EmsConnectivityErrorMessageArguments
from netapp_ontap.models.svm_migration_create import SvmMigrationCreate
from netapp_ontap.models.lun_movement_paths import LunMovementPaths
from netapp_ontap.models.ems_destination_connectivity_errors_message_arguments import EmsDestinationConnectivityErrorsMessageArguments
from netapp_ontap.models.port_metrics_data import PortMetricsData
from netapp_ontap.models.firmware_history_update_state import FirmwareHistoryUpdateState
from netapp_ontap.models.ems_destination_filters import EmsDestinationFilters
from netapp_ontap.models.igroup_nested_records import IgroupNestedRecords
from netapp_ontap.models.performance_svm_nfs_metric_historical_v41 import PerformanceSvmNfsMetricHistoricalV41
from netapp_ontap.models.volume_analytics_scan_throttle_reason import VolumeAnalyticsScanThrottleReason
from netapp_ontap.models.anti_ransomware_attack_report import AntiRansomwareAttackReport
from netapp_ontap.models.group_policy_object_registry_setting import GroupPolicyObjectRegistrySetting
from netapp_ontap.models.portset_interface_portset import PortsetInterfacePortset
from netapp_ontap.models.snaplock_log_volume import SnaplockLogVolume
from netapp_ontap.models.igroup_initiator_records_proximity import IgroupInitiatorRecordsProximity
from netapp_ontap.models.volume_snaplock_retention import VolumeSnaplockRetention
from netapp_ontap.models.rfc2307bis import Rfc2307bis
from netapp_ontap.models.s3_bucket_svm_lifecycle_management_rules import S3BucketSvmLifecycleManagementRules
from netapp_ontap.models.consistency_group_cifs_share import ConsistencyGroupCifsShare
from netapp_ontap.models.s3_bucket_protection_status_destination import S3BucketProtectionStatusDestination
from netapp_ontap.models.ems_filter_response_records_rules import EmsFilterResponseRecordsRules
from netapp_ontap.models.nvme_interface_ip_interface_location import NvmeInterfaceIpInterfaceLocation
from netapp_ontap.models.unix_group_users_unix_group import UnixGroupUsersUnixGroup
from netapp_ontap.models.nfs_service_transport import NfsServiceTransport
from netapp_ontap.models.volume_space_snapshot_autodelete import VolumeSpaceSnapshotAutodelete
from netapp_ontap.models.top_metrics_directory_iops import TopMetricsDirectoryIops
from netapp_ontap.models.s3_bucket_retention import S3BucketRetention
from netapp_ontap.models.volume_snapmirror_destinations import VolumeSnapmirrorDestinations
from netapp_ontap.models.flexcache_relationship import FlexcacheRelationship
from netapp_ontap.models.volume_metric_flexcache import VolumeMetricFlexcache
from netapp_ontap.models.split_load_load import SplitLoadLoad
from netapp_ontap.models.cluster_nodes_management_interfaces import ClusterNodesManagementInterfaces
from netapp_ontap.models.gcp_connectivity import GcpConnectivity
from netapp_ontap.models.consistency_group_igroup_child import ConsistencyGroupIgroupChild
from netapp_ontap.models.vsi_on_san import VsiOnSan
from netapp_ontap.models.fabric_connections import FabricConnections
from netapp_ontap.models.application_cifs_properties import ApplicationCifsProperties
from netapp_ontap.models.node_response_records_cluster_interfaces import NodeResponseRecordsClusterInterfaces
from netapp_ontap.models.export_rule_policy import ExportRulePolicy
from netapp_ontap.models.rotation import Rotation
from netapp_ontap.models.sql_on_san_db_storage_service import SqlOnSanDbStorageService
from netapp_ontap.models.volume_autosize import VolumeAutosize
from netapp_ontap.models.volume_constituents_space import VolumeConstituentsSpace
from netapp_ontap.models.cluster_nodes_ha import ClusterNodesHa
from netapp_ontap.models.igroup_initiators import IgroupInitiators
from netapp_ontap.models.pool_health import PoolHealth
from netapp_ontap.models.web_csrf_token import WebCsrfToken
from netapp_ontap.models.azure_key_vault_key import AzureKeyVaultKey
from netapp_ontap.models.nas_application_components_flexcache import NasApplicationComponentsFlexcache
from netapp_ontap.models.ndmp_mover import NdmpMover
from netapp_ontap.models.cluster_nodes import ClusterNodes
from netapp_ontap.models.performance_svm_response_records import PerformanceSvmResponseRecords
from netapp_ontap.models.nas_application_components import NasApplicationComponents
from netapp_ontap.models.consistency_group_lun import ConsistencyGroupLun
from netapp_ontap.models.dr_node import DrNode
from netapp_ontap.models.ems_syslog_format import EmsSyslogFormat
from netapp_ontap.models.s3_bucket_lifecycle_abort_incomplete_multipart_upload import S3BucketLifecycleAbortIncompleteMultipartUpload
from netapp_ontap.models.volume_statistics import VolumeStatistics
from netapp_ontap.models.cluster_peer_status import ClusterPeerStatus
from netapp_ontap.models.volume_protocol_raw_performance_stat_other import VolumeProtocolRawPerformanceStatOther
from netapp_ontap.models.ems_certificate import EmsCertificate
from netapp_ontap.models.local_cifs_group_members1 import LocalCifsGroupMembers1
from netapp_ontap.models.node_response_records import NodeResponseRecords
from netapp_ontap.models.s3_group_policies import S3GroupPolicies
from netapp_ontap.models.analytics_info_by_modified_time import AnalyticsInfoByModifiedTime
from netapp_ontap.models.fpolicy_policies import FpolicyPolicies
from netapp_ontap.models.license_manager_uri import LicenseManagerUri
from netapp_ontap.models.software_reference_metrocluster_progress_details import SoftwareReferenceMetroclusterProgressDetails
from netapp_ontap.models.svm_migration_ip_interface_placement_ip_interfaces import SvmMigrationIpInterfacePlacementIpInterfaces
from netapp_ontap.models.aggregate_space_block_storage import AggregateSpaceBlockStorage
from netapp_ontap.models.application_rpo_components_rpo_remote import ApplicationRpoComponentsRpoRemote
from netapp_ontap.models.consistency_group_consistency_groups_luns_clone_source import ConsistencyGroupConsistencyGroupsLunsCloneSource
from netapp_ontap.models.iscsi_connection_initiator_address import IscsiConnectionInitiatorAddress
from netapp_ontap.models.lun_location import LunLocation
from netapp_ontap.models.fpolicy_persistent_stores import FpolicyPersistentStores
from netapp_ontap.models.cloud_target_cluster import CloudTargetCluster
from netapp_ontap.models.volume_constituents_movement import VolumeConstituentsMovement
from netapp_ontap.models.ikp_connectivity import IkpConnectivity
from netapp_ontap.models.consistency_group_lun_space_guarantee import ConsistencyGroupLunSpaceGuarantee
from netapp_ontap.models.token_expiry_time import TokenExpiryTime
from netapp_ontap.models.cifs_domain_preferred_dc_status import CifsDomainPreferredDcStatus
from netapp_ontap.models.consistency_group_clone1_volume import ConsistencyGroupClone1Volume
from netapp_ontap.models.nfs_service_qtree import NfsServiceQtree
from netapp_ontap.models.uniform_resource_identifier import UniformResourceIdentifier
from netapp_ontap.models.igroup_initiator_proximity_peer_svms import IgroupInitiatorProximityPeerSvms
from netapp_ontap.models.node_response_records_management_interfaces import NodeResponseRecordsManagementInterfaces
from netapp_ontap.models.rfc2307 import Rfc2307
from netapp_ontap.models.volume_analytics_initialization import VolumeAnalyticsInitialization
from netapp_ontap.models.aggr_space_efficiency import AggrSpaceEfficiency
from netapp_ontap.models.file_move_files_to_move_sources import FileMoveFilesToMoveSources
from netapp_ontap.models.shelf_vendor import ShelfVendor
from netapp_ontap.models.aggregate_inode_attributes import AggregateInodeAttributes
from netapp_ontap.models.license_keys import LicenseKeys
from netapp_ontap.models.security_association_ipsec_inbound import SecurityAssociationIpsecInbound
from netapp_ontap.models.fpolicy_engine_certificate import FpolicyEngineCertificate
from netapp_ontap.models.application_rpo import ApplicationRpo
from netapp_ontap.models.cluster_nodes_management_interface import ClusterNodesManagementInterface
from netapp_ontap.models.group_policy_object_registry_value import GroupPolicyObjectRegistryValue
from netapp_ontap.models.node_metrics_response_records import NodeMetricsResponseRecords
from netapp_ontap.models.igroup_replication_error import IgroupReplicationError
from netapp_ontap.models.snaplock_litigation_file_response_records import SnaplockLitigationFileResponseRecords
from netapp_ontap.models.fc_zone_member import FcZoneMember
from netapp_ontap.models.ip_interface_svm_ip import IpInterfaceSvmIp
from netapp_ontap.models.performance_metric_response_records import PerformanceMetricResponseRecords
from netapp_ontap.models.kerberos_realm_kdc import KerberosRealmKdc
from netapp_ontap.models.log import Log
from netapp_ontap.models.oracle_rac_on_nfs_grid_binary import OracleRacOnNfsGridBinary
from netapp_ontap.models.ems_parameter_criterion import EmsParameterCriterion
from netapp_ontap.models.application_statistics_components_storage_service import ApplicationStatisticsComponentsStorageService
from netapp_ontap.models.analytics_collection_info import AnalyticsCollectionInfo
from netapp_ontap.models.cluster_nodes_ha_takeover_failure import ClusterNodesHaTakeoverFailure
from netapp_ontap.models.mongo_db_on_san_secondary_igroups import MongoDbOnSanSecondaryIgroups
from netapp_ontap.models.node_cluster_interfaces import NodeClusterInterfaces
from netapp_ontap.models.cluster_peer_local_network import ClusterPeerLocalNetwork
from netapp_ontap.models.tape_device_alias import TapeDeviceAlias
from netapp_ontap.models.vdi_on_nas_desktops import VdiOnNasDesktops
from netapp_ontap.models.security_association_ike import SecurityAssociationIke
from netapp_ontap.models.bgp_peer_group_peer import BgpPeerGroupPeer
from netapp_ontap.models.volume_movement import VolumeMovement
from netapp_ontap.models.tape_device_position import TapeDevicePosition
from netapp_ontap.models.igroup_initiator_connectivity_tracking_connections_logins import IgroupInitiatorConnectivityTrackingConnectionsLogins
from netapp_ontap.models.metrocluster_dr_pairs import MetroclusterDrPairs
from netapp_ontap.models.security_key_manager_restore_keys import SecurityKeyManagerRestoreKeys
from netapp_ontap.models.svm_s3_service import SvmS3Service
from netapp_ontap.models.top_metrics_directory_throughput import TopMetricsDirectoryThroughput
from netapp_ontap.models.performance_fcp_metric_svm import PerformanceFcpMetricSvm
from netapp_ontap.models.nvme_subsystem_host_io_queue import NvmeSubsystemHostIoQueue
from netapp_ontap.models.analytics_collection_info_by_accessed_time_bytes_used import AnalyticsCollectionInfoByAccessedTimeBytesUsed
from netapp_ontap.models.binding_details import BindingDetails
from netapp_ontap.models.chassis_nodes_pcis_cards import ChassisNodesPcisCards
from netapp_ontap.models.ems_event_message1 import EmsEventMessage1
from netapp_ontap.models.bgp_peer_group_local_port_node import BgpPeerGroupLocalPortNode
from netapp_ontap.models.firmware_update_progress_state import FirmwareUpdateProgressState
from netapp_ontap.models.nas_application_components_flexcache_origin import NasApplicationComponentsFlexcacheOrigin
from netapp_ontap.models.mongo_db_on_san_dataset import MongoDbOnSanDataset
from netapp_ontap.models.bgp_peer_group_local import BgpPeerGroupLocal
from netapp_ontap.models.aggregate_block_storage_hybrid_cache_simulated_raid_groups import AggregateBlockStorageHybridCacheSimulatedRaidGroups
from netapp_ontap.models.s3_service_delete import S3ServiceDelete
from netapp_ontap.models.cluster_nodes_ha_giveback_status_error import ClusterNodesHaGivebackStatusError
from netapp_ontap.models.application_statistics_space import ApplicationStatisticsSpace
from netapp_ontap.models.multi_admin_verify_approval_group_owner import MultiAdminVerifyApprovalGroupOwner
from netapp_ontap.models.storage_switch_paths_adapter import StorageSwitchPathsAdapter
from netapp_ontap.models.broadcast_domain_ports import BroadcastDomainPorts
from netapp_ontap.models.replication_error_igroup import ReplicationErrorIgroup
from netapp_ontap.models.error_arguments import ErrorArguments
from netapp_ontap.models.ems_filter_rule_response_records import EmsFilterRuleResponseRecords
from netapp_ontap.models.storage_switch_vsans import StorageSwitchVsans
from netapp_ontap.models.entitlement import Entitlement
from netapp_ontap.models.consistency_group_consistency_groups_luns_clone import ConsistencyGroupConsistencyGroupsLunsClone
from netapp_ontap.models.app_cifs_access import AppCifsAccess
from netapp_ontap.models.ems_event_action import EmsEventAction
from netapp_ontap.models.local_user_membership import LocalUserMembership
from netapp_ontap.models.ems_message_response_records import EmsMessageResponseRecords
from netapp_ontap.models.nvme_interface_ip_interface_ip import NvmeInterfaceIpInterfaceIp
from netapp_ontap.models.consistency_group_clone1_guarantee import ConsistencyGroupClone1Guarantee
from netapp_ontap.models.consistency_group_provisioning_options import ConsistencyGroupProvisioningOptions
from netapp_ontap.models.consistency_group_tiering import ConsistencyGroupTiering
from netapp_ontap.models.top_metrics_client_response_incomplete_response_reason import TopMetricsClientResponseIncompleteResponseReason
from netapp_ontap.models.consistency_group_consistency_groups_provisioning_options_storage_service import ConsistencyGroupConsistencyGroupsProvisioningOptionsStorageService
from netapp_ontap.models.snaplock_file_fingerprint_get import SnaplockFileFingerprintGet
from netapp_ontap.models.s3_bucket_svm_lifecycle_management import S3BucketSvmLifecycleManagement
from netapp_ontap.models.port_lag import PortLag
from netapp_ontap.models.fabric_connections_switch_port import FabricConnectionsSwitchPort
from netapp_ontap.models.storage_bridge_last_reboot import StorageBridgeLastReboot
from netapp_ontap.models.vdi_on_san import VdiOnSan
from netapp_ontap.models.app_nfs_access import AppNfsAccess
from netapp_ontap.models.lun_convert import LunConvert
from netapp_ontap.models.active_directory_discovered_server import ActiveDirectoryDiscoveredServer
from netapp_ontap.models.svm_migration_destination import SvmMigrationDestination
from netapp_ontap.models.nas_application_components_tiering import NasApplicationComponentsTiering
from netapp_ontap.models.zapp_nvme_components_subsystem_hosts_dh_hmac_chap import ZappNvmeComponentsSubsystemHostsDhHmacChap
from netapp_ontap.models.oracle_on_nfs_redo_log import OracleOnNfsRedoLog
from netapp_ontap.models.sql_on_san_log_storage_service import SqlOnSanLogStorageService
from netapp_ontap.models.storage_bridge_paths_source_port import StorageBridgePathsSourcePort
from netapp_ontap.models.key_manager_state import KeyManagerState
from netapp_ontap.models.group_policy_object_event_log import GroupPolicyObjectEventLog
from netapp_ontap.models.nvme_subsystem_io_queue_default import NvmeSubsystemIoQueueDefault
from netapp_ontap.models.volume_encryption_support import VolumeEncryptionSupport
from netapp_ontap.models.nas_application_components_qos import NasApplicationComponentsQos
from netapp_ontap.models.ems_filter_rules_parameter_criteria import EmsFilterRulesParameterCriteria
from netapp_ontap.models.layout_requirement_raid_group import LayoutRequirementRaidGroup
from netapp_ontap.models.vscan_on_demand_scope import VscanOnDemandScope
from netapp_ontap.models.ipv6_interface_and_gateway import Ipv6InterfaceAndGateway
from netapp_ontap.models.web_certificate import WebCertificate
from netapp_ontap.models.san import San
from netapp_ontap.models.igroup_initiator_proximity import IgroupInitiatorProximity
from netapp_ontap.models.consistency_group_consistency_groups_volumes_nas_junction_parent import ConsistencyGroupConsistencyGroupsVolumesNasJunctionParent
from netapp_ontap.models.nfs_service_protocol_v41_features import NfsServiceProtocolV41Features
from netapp_ontap.models.ldap_schema_account import LdapSchemaAccount
from netapp_ontap.models.s3_service_post_response_records import S3ServicePostResponseRecords
from netapp_ontap.models.sql_on_san_temp_db_storage_service import SqlOnSanTempDbStorageService
from netapp_ontap.models.svm_ldap import SvmLdap
from netapp_ontap.models.aggregate_space_cloud_storage import AggregateSpaceCloudStorage
from netapp_ontap.models.cifs_service_security import CifsServiceSecurity
from netapp_ontap.models.cluster_nodes_service_processor_backup import ClusterNodesServiceProcessorBackup
from netapp_ontap.models.metrocluster_remote import MetroclusterRemote
from netapp_ontap.models.tape_device_aliases import TapeDeviceAliases
from netapp_ontap.models.storage_switch_temperature_sensors import StorageSwitchTemperatureSensors
from netapp_ontap.models.cluster_nodes_cluster_interface import ClusterNodesClusterInterface
from netapp_ontap.models.volume_efficiency_scanner import VolumeEfficiencyScanner
from netapp_ontap.models.security_oauth2_introspection import SecurityOauth2Introspection
from netapp_ontap.models.nvme_dh_hmac_chap_authentication import NvmeDhHmacChapAuthentication
from netapp_ontap.models.performance_network_metrics import PerformanceNetworkMetrics
from netapp_ontap.models.storage_bridge_power_supply_units import StorageBridgePowerSupplyUnits
from netapp_ontap.models.anti_ransomware_volume_suspect_files import AntiRansomwareVolumeSuspectFiles
from netapp_ontap.models.fabric_zoneset import FabricZoneset
from netapp_ontap.models.nfs_service_exports import NfsServiceExports
from netapp_ontap.models.service_processor import ServiceProcessor
from netapp_ontap.models.igroup_initiator_no_records_proximity_peer_svms import IgroupInitiatorNoRecordsProximityPeerSvms
from netapp_ontap.models.volume_tiering import VolumeTiering
from netapp_ontap.models.vsi_on_san_new_igroups import VsiOnSanNewIgroups
from netapp_ontap.models.volume_nas_junction_parent import VolumeNasJunctionParent
from netapp_ontap.models.nas_application_components_storage_service import NasApplicationComponentsStorageService
from netapp_ontap.models.performance_metric_raw import PerformanceMetricRaw
from netapp_ontap.models.volume_constituents import VolumeConstituents
from netapp_ontap.models.volume_qos import VolumeQos
from netapp_ontap.models.cluster_peer_initial_allowed_svms import ClusterPeerInitialAllowedSvms
from netapp_ontap.models.consistency_group_consistency_groups_luns_lun_maps_igroup_igroups import ConsistencyGroupConsistencyGroupsLunsLunMapsIgroupIgroups
from netapp_ontap.models.fpolicy_engine_resiliency import FpolicyEngineResiliency
from netapp_ontap.models.volume_guarantee import VolumeGuarantee
from netapp_ontap.models.igroup_initiators_connectivity_tracking import IgroupInitiatorsConnectivityTracking
from netapp_ontap.models.node_ha_giveback import NodeHaGiveback
from netapp_ontap.models.cluster_nodes_service_processor_primary import ClusterNodesServiceProcessorPrimary
from netapp_ontap.models.file_move_file import FileMoveFile
from netapp_ontap.models.raid_group_disk import RaidGroupDisk
from netapp_ontap.models.node_uuid import NodeUuid
from netapp_ontap.models.port_vlan import PortVlan
from netapp_ontap.models.software_reference_metrocluster_progress_summary import SoftwareReferenceMetroclusterProgressSummary
from netapp_ontap.models.analytics_collection_info_by_accessed_time import AnalyticsCollectionInfoByAccessedTime
from netapp_ontap.models.security_saml_sp_certificate import SecuritySamlSpCertificate
from netapp_ontap.models.snapmirror_relationship_policy import SnapmirrorRelationshipPolicy
from netapp_ontap.models.s3_bucket_lifecycle_non_current_version_expiration import S3BucketLifecycleNonCurrentVersionExpiration
from netapp_ontap.models.unix_group_users_records import UnixGroupUsersRecords
from netapp_ontap.models.application_statistics_components_latency import ApplicationStatisticsComponentsLatency
from netapp_ontap.models.nvme_subsystem_hosts import NvmeSubsystemHosts
from netapp_ontap.models.ad_domain import AdDomain
from netapp_ontap.models.oracle_rac_on_nfs_oracle_crs import OracleRacOnNfsOracleCrs
from netapp_ontap.models.qtree_user import QtreeUser
from netapp_ontap.models.storage_bridge_errors_component import StorageBridgeErrorsComponent
from netapp_ontap.models.volume_rebalancing1_engine_scanner import VolumeRebalancing1EngineScanner
from netapp_ontap.models.application_statistics_latency import ApplicationStatisticsLatency
from netapp_ontap.models.flexcache_cifs_change_notify import FlexcacheCifsChangeNotify
from netapp_ontap.models.scope_ipspace import ScopeIpspace
from netapp_ontap.models.top_metrics_client_response_notice import TopMetricsClientResponseNotice
from netapp_ontap.models.s3_server_warning import S3ServerWarning
from netapp_ontap.models.s3_bucket_protection_status import S3BucketProtectionStatus
from netapp_ontap.models.vdi_on_nas_hyper_v_access import VdiOnNasHyperVAccess
from netapp_ontap.models.snapmirror_endpoint import SnapmirrorEndpoint
from netapp_ontap.models.security_keystore_configuration import SecurityKeystoreConfiguration
from netapp_ontap.models.ems_event_action_title_arguments import EmsEventActionTitleArguments
from netapp_ontap.models.performance_iscsi_metric_response_records import PerformanceIscsiMetricResponseRecords
from netapp_ontap.models.volume_rebalancing1_engine_scanner_files_skipped import VolumeRebalancing1EngineScannerFilesSkipped
from netapp_ontap.models.performance_metric_raw_reduced_throughput import PerformanceMetricRawReducedThroughput
from netapp_ontap.models.sql_on_san_log import SqlOnSanLog
from netapp_ontap.models.ip_interface_svm_location import IpInterfaceSvmLocation
from netapp_ontap.models.performance_cifs_metric_response_records import PerformanceCifsMetricResponseRecords
from netapp_ontap.models.shelf_paths import ShelfPaths
from netapp_ontap.models.autosupport_connectivity_issue import AutosupportConnectivityIssue
from netapp_ontap.models.shelf_ports_cable import ShelfPortsCable
from netapp_ontap.models.consistency_group_child_luns_lun_maps_igroup_igroups import ConsistencyGroupChildLunsLunMapsIgroupIgroups
from netapp_ontap.models.svm_storage import SvmStorage
from netapp_ontap.models.ldap_schema_name_mapping import LdapSchemaNameMapping
from netapp_ontap.models.shelf_frus import ShelfFrus
from netapp_ontap.models.consistency_group_response_records_consistency_groups_luns_lun_maps import ConsistencyGroupResponseRecordsConsistencyGroupsLunsLunMaps
from netapp_ontap.models.s3_bucket_aggregates import S3BucketAggregates
from netapp_ontap.models.cn import Cn
from netapp_ontap.models.application_rpo_components_rpo_local import ApplicationRpoComponentsRpoLocal
from netapp_ontap.models.consistency_group_snapshot_response_records import ConsistencyGroupSnapshotResponseRecords
from netapp_ontap.models.s3_user_post_patch import S3UserPostPatch
from netapp_ontap.models.application_rpo_components import ApplicationRpoComponents
from netapp_ontap.models.iscsi_credentials_chap_inbound import IscsiCredentialsChapInbound
from netapp_ontap.models.nfs_service_protocol_v40_features import NfsServiceProtocolV40Features
from netapp_ontap.models.cifs_session_volumes import CifsSessionVolumes
from netapp_ontap.models.software_data_encryption import SoftwareDataEncryption
from netapp_ontap.models.svm_migration_ip_interface_port import SvmMigrationIpInterfacePort
from netapp_ontap.models.volume_efficiency_policy1 import VolumeEfficiencyPolicy1
from netapp_ontap.models.switch_port_remote_port_device_shelf import SwitchPortRemotePortDeviceShelf
from netapp_ontap.models.top_metrics_svm_client_excluded_volume import TopMetricsSvmClientExcludedVolume
from netapp_ontap.models.oracle_rac_on_nfs_oracle_crs_storage_service import OracleRacOnNfsOracleCrsStorageService
from netapp_ontap.models.network_route_interfaces import NetworkRouteInterfaces
from netapp_ontap.models.node_ha_giveback_status import NodeHaGivebackStatus
from netapp_ontap.models.job_link import JobLink
from netapp_ontap.models.cluster_peer_encryption import ClusterPeerEncryption
from netapp_ontap.models.fc_interface_svm_location import FcInterfaceSvmLocation
from netapp_ontap.models.consistency_group_consistency_groups_luns_lun_maps_igroup_initiators import ConsistencyGroupConsistencyGroupsLunsLunMapsIgroupInitiators
from netapp_ontap.models.igroup_initiator_connectivity_tracking import IgroupInitiatorConnectivityTracking
from netapp_ontap.models.switch_monitoring import SwitchMonitoring
from netapp_ontap.models.quota_report_qtree import QuotaReportQtree
from netapp_ontap.models.fc_switch_ports_attached_device import FcSwitchPortsAttachedDevice
from netapp_ontap.models.portset_igroups import PortsetIgroups
from netapp_ontap.models.svm_migration_volume_aggregate_pair import SvmMigrationVolumeAggregatePair
from netapp_ontap.models.top_metric_value_error_bounds import TopMetricValueErrorBounds
from netapp_ontap.models.consistency_group_child_volumes import ConsistencyGroupChildVolumes
from netapp_ontap.models.key_manager_config_health_monitor_policy import KeyManagerConfigHealthMonitorPolicy
from netapp_ontap.models.volume_statistics_cloud import VolumeStatisticsCloud
from netapp_ontap.models.shelf_drawers import ShelfDrawers
from netapp_ontap.models.top_metrics_file_throughput import TopMetricsFileThroughput
from netapp_ontap.models.igroup_parent import IgroupParent
from netapp_ontap.models.autosupport_message_error import AutosupportMessageError
from netapp_ontap.models.consistency_group_consistency_groups_namespaces import ConsistencyGroupConsistencyGroupsNamespaces
from netapp_ontap.models.ems_filter_rule_parameter_criteria import EmsFilterRuleParameterCriteria
from netapp_ontap.models.fc_login_initiator import FcLoginInitiator
from netapp_ontap.models.tape_device_device_names import TapeDeviceDeviceNames
from netapp_ontap.models.lun_map_igroup import LunMapIgroup
from netapp_ontap.models.preferred_dcs import PreferredDcs
from netapp_ontap.models.snaplock_retention_policy_operation import SnaplockRetentionPolicyOperation
from netapp_ontap.models.igroup_connectivity_tracking import IgroupConnectivityTracking
from netapp_ontap.models.shelf_errors import ShelfErrors
from netapp_ontap.models.nas_application_components_flexcache_origin_svm import NasApplicationComponentsFlexcacheOriginSvm
from netapp_ontap.models.fc_switch_ports import FcSwitchPorts
from netapp_ontap.models.fpolicy_policies_scope import FpolicyPoliciesScope
from netapp_ontap.models.metrocluster_dr_group_mccip_ports import MetroclusterDrGroupMccipPorts
from netapp_ontap.models.cluster_nis_service_binding_details import ClusterNisServiceBindingDetails
from netapp_ontap.models.volume_rebalancing1_engine_movement_last_error import VolumeRebalancing1EngineMovementLastError
from netapp_ontap.models.performance_svm_nfs_response_records import PerformanceSvmNfsResponseRecords
from netapp_ontap.models.software_status_details_reference_node import SoftwareStatusDetailsReferenceNode
from netapp_ontap.models.nvme_subsystem_controller_interface import NvmeSubsystemControllerInterface
from netapp_ontap.models.ems_destination_response_records_connectivity import EmsDestinationResponseRecordsConnectivity
from netapp_ontap.models.certificate_signing_request import CertificateSigningRequest
from netapp_ontap.models.storage_bridge_temperature_sensor import StorageBridgeTemperatureSensor
from netapp_ontap.models.volume_encryption import VolumeEncryption
from netapp_ontap.models.file_move_files_to_move_destinations import FileMoveFilesToMoveDestinations
from netapp_ontap.models.application_template1 import ApplicationTemplate1
from netapp_ontap.models.software_reference_metrocluster import SoftwareReferenceMetrocluster
from netapp_ontap.models.s3_audit_events import S3AuditEvents
from netapp_ontap.models.nas_application_components_tiering_object_stores import NasApplicationComponentsTieringObjectStores
from netapp_ontap.models.schedule_cron import ScheduleCron
from netapp_ontap.models.cluster_nodes_metrocluster_ports import ClusterNodesMetroclusterPorts
from netapp_ontap.models.svm_iscsi import SvmIscsi
from netapp_ontap.models.cluster_management_interface import ClusterManagementInterface
from netapp_ontap.models.nvme_subsystem_controller_dh_hmac_chap import NvmeSubsystemControllerDhHmacChap
from netapp_ontap.models.performance_metric_raw_svm import PerformanceMetricRawSvm
from netapp_ontap.models.aggregate_block_storage_primary_simulated_raid_groups import AggregateBlockStoragePrimarySimulatedRaidGroups
from netapp_ontap.models.autosupport_connectivity_corrective_action import AutosupportConnectivityCorrectiveAction
from netapp_ontap.models.consistency_group_cifs_share_acls import ConsistencyGroupCifsShareAcls
from netapp_ontap.models.lun_map_reporting_nodes import LunMapReportingNodes
from netapp_ontap.models.consistency_group_replication_relationships import ConsistencyGroupReplicationRelationships
from netapp_ontap.models.application_protection_groups import ApplicationProtectionGroups
from netapp_ontap.models.posix import Posix
from netapp_ontap.models.nfs_service_root import NfsServiceRoot
from netapp_ontap.models.share_lock import ShareLock
from netapp_ontap.models.snapmirror_destination_creation_storage_service import SnapmirrorDestinationCreationStorageService
from netapp_ontap.models.application_statistics_components_snapshot import ApplicationStatisticsComponentsSnapshot
from netapp_ontap.models.metrocluster_diag_connection_details import MetroclusterDiagConnectionDetails
from netapp_ontap.models.oracle_rac_on_nfs_grid_binary_storage_service import OracleRacOnNfsGridBinaryStorageService
from netapp_ontap.models.consistency_group_response_records_consistency_groups_luns_lun_maps_igroup_igroups import ConsistencyGroupResponseRecordsConsistencyGroupsLunsLunMapsIgroupIgroups
from netapp_ontap.models.consistency_group_consistency_groups_volumes_nas_cifs import ConsistencyGroupConsistencyGroupsVolumesNasCifs
from netapp_ontap.models.group_policy_object_privilege_right import GroupPolicyObjectPrivilegeRight
from netapp_ontap.models.volume_snapmirror import VolumeSnapmirror
from netapp_ontap.models.counter import Counter
from netapp_ontap.models.performance_fcp_metric_response_records import PerformanceFcpMetricResponseRecords
from netapp_ontap.models.security_certificate_sign import SecurityCertificateSign
from netapp_ontap.models.cluster_nodes_metrocluster import ClusterNodesMetrocluster
from netapp_ontap.models.group_policy_object_kerberos import GroupPolicyObjectKerberos
from netapp_ontap.models.quota_rule_space import QuotaRuleSpace
from netapp_ontap.models.cluster_nodes_snaplock import ClusterNodesSnaplock
from netapp_ontap.models.volume_snaplock import VolumeSnaplock
from netapp_ontap.models.disk_outage import DiskOutage
from netapp_ontap.models.s3_bucket_lifecycle_management import S3BucketLifecycleManagement
from netapp_ontap.models.shelf_current_sensors import ShelfCurrentSensors
from netapp_ontap.models.device_discovery_data import DeviceDiscoveryData
from netapp_ontap.models.security_azure import SecurityAzure
from netapp_ontap.models.svm_snapmirror import SvmSnapmirror
from netapp_ontap.models.svm_migration_volume_placement import SvmMigrationVolumePlacement
from netapp_ontap.models.ems_event_action_confirmation_message_arguments import EmsEventActionConfirmationMessageArguments
from netapp_ontap.models.storage_port_cable import StoragePortCable
from netapp_ontap.models.s3_bucket_svm_encryption import S3BucketSvmEncryption
from netapp_ontap.models.zapp_nvme import ZappNvme
from netapp_ontap.models.group_policy_object_event_audit import GroupPolicyObjectEventAudit
from netapp_ontap.models.software_update_details_reference_node import SoftwareUpdateDetailsReferenceNode
from netapp_ontap.models.quota_report_files import QuotaReportFiles
from netapp_ontap.models.security_key_manager_onboard import SecurityKeyManagerOnboard
from netapp_ontap.models.performance_namespace_metric_response_records import PerformanceNamespaceMetricResponseRecords
from netapp_ontap.models.cluster_peering_policy import ClusterPeeringPolicy
from netapp_ontap.models.broadcast_domain_reference_ipspace import BroadcastDomainReferenceIpspace
from netapp_ontap.models.oracle_on_nfs_db import OracleOnNfsDb
from netapp_ontap.models.lun_copy_source_progress import LunCopySourceProgress
from netapp_ontap.models.lun_vvol_bindings_partner import LunVvolBindingsPartner
from netapp_ontap.models.analytics_collection_info_by_modified_time_bytes_used import AnalyticsCollectionInfoByModifiedTimeBytesUsed
from netapp_ontap.models.group_policy_object_branchcache import GroupPolicyObjectBranchcache
from netapp_ontap.models.igroup_initiators_links import IgroupInitiatorsLinks
from netapp_ontap.models.application_component_svm import ApplicationComponentSvm
from netapp_ontap.models.anti_ransomware_volume_attack_detection_parameters import AntiRansomwareVolumeAttackDetectionParameters
from netapp_ontap.models.cifs_open_file_connection import CifsOpenFileConnection
from netapp_ontap.models.vscan_on_access_scope import VscanOnAccessScope
from netapp_ontap.models.license_package_response_records import LicensePackageResponseRecords
from netapp_ontap.models.snapmirror_transfer_relationship import SnapmirrorTransferRelationship
from netapp_ontap.models.security_key_manager_external_server_ca_certificates import SecurityKeyManagerExternalServerCaCertificates
from netapp_ontap.models.local_cifs_group_members_records import LocalCifsGroupMembersRecords
from netapp_ontap.models.consistency_group_lun_space import ConsistencyGroupLunSpace
from netapp_ontap.models.oracle_on_san_new_igroups import OracleOnSanNewIgroups
from netapp_ontap.models.volume_clone import VolumeClone
from netapp_ontap.models.ipsec_ca_certificate_uuid import IpsecCaCertificateUuid
from netapp_ontap.models.status import Status
from netapp_ontap.models.server import Server
from netapp_ontap.models.nvme_namespace_convert_lun import NvmeNamespaceConvertLun
from netapp_ontap.models.security_association_ipsec import SecurityAssociationIpsec
from netapp_ontap.models.consistency_group_luns_lun_maps import ConsistencyGroupLunsLunMaps
from netapp_ontap.models.performance_reduced_throughput import PerformanceReducedThroughput
from netapp_ontap.models.smb import Smb
from netapp_ontap.models.firmware_sp_bmc import FirmwareSpBmc
from netapp_ontap.models.ems_filter_response_records_rules_parameter_criteria import EmsFilterResponseRecordsRulesParameterCriteria
from netapp_ontap.models.file import File
from netapp_ontap.models.igroup_initiators_proximity import IgroupInitiatorsProximity
from netapp_ontap.models.member import Member
from netapp_ontap.models.cifs_ad_domain import CifsAdDomain
from netapp_ontap.models.s3_bucket_svm_protection_status_destination import S3BucketSvmProtectionStatusDestination
from netapp_ontap.models.snaplock_log_file import SnaplockLogFile
from netapp_ontap.models.metrocluster_diagnostics_aggregate import MetroclusterDiagnosticsAggregate
from netapp_ontap.models.metrocluster_diag_connection import MetroclusterDiagConnection
from netapp_ontap.models.nvme_namespace_clone import NvmeNamespaceClone
from netapp_ontap.models.port_lag_member_ports import PortLagMemberPorts
from netapp_ontap.models.unix_group_users1 import UnixGroupUsers1
from netapp_ontap.models.uri import Uri
from netapp_ontap.models.aggregate_data_encryption import AggregateDataEncryption
from netapp_ontap.models.s3_service_delete_response_records import S3ServiceDeleteResponseRecords
from netapp_ontap.models.nas_application_components_snaplock import NasApplicationComponentsSnaplock
from netapp_ontap.models.aggregate_space_snapshot import AggregateSpaceSnapshot
from netapp_ontap.models.mccip_port_l3_config import MccipPortL3Config
from netapp_ontap.models.snapmirror_endpoint_consistency_group_volumes import SnapmirrorEndpointConsistencyGroupVolumes
from netapp_ontap.models.igroup_initiator_records_proximity_peer_svms import IgroupInitiatorRecordsProximityPeerSvms
from netapp_ontap.models.mediator_response_records import MediatorResponseRecords
from netapp_ontap.models.application_protection_groups_rpo_local import ApplicationProtectionGroupsRpoLocal
from netapp_ontap.models.switch_snmp import SwitchSnmp
from netapp_ontap.models.cluster_nodes_controller_failed_power_supply import ClusterNodesControllerFailedPowerSupply
from netapp_ontap.models.ems_event_response_records import EmsEventResponseRecords
from netapp_ontap.models.quota_rule_files import QuotaRuleFiles
from netapp_ontap.models.s3_audit_event_selector import S3AuditEventSelector
from netapp_ontap.models.anti_ransomware_volume_workload_surge_usage import AntiRansomwareVolumeWorkloadSurgeUsage
from netapp_ontap.models.chassis_frus import ChassisFrus
from netapp_ontap.models.cloud_store_aggregate import CloudStoreAggregate
from netapp_ontap.models.ems_event_parameters import EmsEventParameters
from netapp_ontap.models.web_csrf import WebCsrf
from netapp_ontap.models.consistency_group_consistency_groups_volumes import ConsistencyGroupConsistencyGroupsVolumes
from netapp_ontap.models.shelf_fans import ShelfFans
from netapp_ontap.models.usm import Usm
from netapp_ontap.models.ipsec_endpoint import IpsecEndpoint
from netapp_ontap.models.fc_interface_response_recommend import FcInterfaceResponseRecommend
from netapp_ontap.models.zapp_s3_bucket_protection_type import ZappS3BucketProtectionType
from netapp_ontap.models.s3_service_user_post import S3ServiceUserPost
from netapp_ontap.models.lun_map_lun_node import LunMapLunNode
from netapp_ontap.models.storage_switch_errors_component import StorageSwitchErrorsComponent
from netapp_ontap.models.software_package_download_get import SoftwarePackageDownloadGet
from netapp_ontap.models.advanced_rights import AdvancedRights
from netapp_ontap.models.cluster_nodes_ha_interconnect import ClusterNodesHaInterconnect
from netapp_ontap.models.svm_migration_volume_placement_volume_aggregate_pairs import SvmMigrationVolumePlacementVolumeAggregatePairs
from netapp_ontap.models.cluster_nodes_ha_giveback_failure import ClusterNodesHaGivebackFailure
from netapp_ontap.models.metrocluster_diagnostics_volume import MetroclusterDiagnosticsVolume
from netapp_ontap.models.svm_nvme import SvmNvme
from netapp_ontap.models.application_nvme_access_backing_storage import ApplicationNvmeAccessBackingStorage
from netapp_ontap.models.snapshot_delta import SnapshotDelta
from netapp_ontap.models.ems_filter_rules import EmsFilterRules
from netapp_ontap.models.storage_bridge_sas_ports_phy2 import StorageBridgeSasPortsPhy2
from netapp_ontap.models.storage_bridge_sas_ports_phy1 import StorageBridgeSasPortsPhy1
from netapp_ontap.models.storage_switch_connections_peer_port import StorageSwitchConnectionsPeerPort
from netapp_ontap.models.storage_bridge_sas_ports_phy4 import StorageBridgeSasPortsPhy4
from netapp_ontap.models.consistency_group_volume_space import ConsistencyGroupVolumeSpace
from netapp_ontap.models.storage_bridge_sas_ports_phy3 import StorageBridgeSasPortsPhy3
from netapp_ontap.models.aggregate_block_storage import AggregateBlockStorage
from netapp_ontap.models.consistency_group_lun_lun_maps import ConsistencyGroupLunLunMaps
from netapp_ontap.models.license import License
from netapp_ontap.models.fpolicy_engine_buffer_size import FpolicyEngineBufferSize
from netapp_ontap.models.nfs_service_access_cache_config import NfsServiceAccessCacheConfig
from netapp_ontap.models.application_snapshot_application import ApplicationSnapshotApplication
from netapp_ontap.models.shelf_bays import ShelfBays
from netapp_ontap.models.application_snapshot_restore import ApplicationSnapshotRestore
from netapp_ontap.models.arw_vserver import ArwVserver
from netapp_ontap.models.iscsi_credentials_chap_outbound import IscsiCredentialsChapOutbound
from netapp_ontap.models.software_status_details_reference_action import SoftwareStatusDetailsReferenceAction
from netapp_ontap.models.broadcast_domain_svm import BroadcastDomainSvm
from netapp_ontap.models.cluster_nodes_nvram import ClusterNodesNvram
from netapp_ontap.models.software_validation_reference_action import SoftwareValidationReferenceAction
from netapp_ontap.models.local_cifs_group_members_no_records import LocalCifsGroupMembersNoRecords
from netapp_ontap.models.volume_analytics_unsupported_reason import VolumeAnalyticsUnsupportedReason
from netapp_ontap.models.lun_vvol import LunVvol
from netapp_ontap.models.node_response_records_ha_partners import NodeResponseRecordsHaPartners
from netapp_ontap.models.port_statistics_packet_counters import PortStatisticsPacketCounters
from netapp_ontap.models.collection_links import CollectionLinks
from netapp_ontap.models.storage_bridge_fc_ports_sfp import StorageBridgeFcPortsSfp
from netapp_ontap.models.lun_copy_destinations import LunCopyDestinations
from netapp_ontap.models.metrocluster_partner import MetroclusterPartner
from netapp_ontap.models.consistency_group_namespace_space import ConsistencyGroupNamespaceSpace
from netapp_ontap.models.svm_cifs_service import SvmCifsService
from netapp_ontap.models.igroup_initiator_connectivity_tracking_connections import IgroupInitiatorConnectivityTrackingConnections
from netapp_ontap.models.analytics_collection_info_by_modified_time import AnalyticsCollectionInfoByModifiedTime
from netapp_ontap.models.cifs_domain_trust import CifsDomainTrust
from netapp_ontap.models.storage_switch_paths_port import StorageSwitchPathsPort
from netapp_ontap.models.iscsi_session_initiator import IscsiSessionInitiator
from netapp_ontap.models.aggregate_inactive_data_reporting import AggregateInactiveDataReporting
from netapp_ontap.models.zapp_nvme_components_tiering import ZappNvmeComponentsTiering
from netapp_ontap.models.nvme_namespace_clone_source import NvmeNamespaceCloneSource
from netapp_ontap.models.cluster_nodes_ha_partners import ClusterNodesHaPartners
from netapp_ontap.models.nvme_namespace_convert import NvmeNamespaceConvert
from netapp_ontap.models.application_lun_object import ApplicationLunObject
from netapp_ontap.models.detailed_status_code_message import DetailedStatusCodeMessage
from netapp_ontap.models.s3_bucket_policy_condition import S3BucketPolicyCondition
from netapp_ontap.models.volume_efficiency_policy_schedule import VolumeEfficiencyPolicySchedule
from netapp_ontap.models.fc_interface_location_home_port_node import FcInterfaceLocationHomePortNode
from netapp_ontap.models.top_metrics_svm_user_throughput import TopMetricsSvmUserThroughput
from netapp_ontap.models.gcp_kms_state import GcpKmsState
from netapp_ontap.models.nfs_service_security import NfsServiceSecurity
from netapp_ontap.models.consistency_group_consistency_groups_luns_lun_maps import ConsistencyGroupConsistencyGroupsLunsLunMaps
from netapp_ontap.models.volume_flexgroup import VolumeFlexgroup
from netapp_ontap.models.consistency_group_metrics_response_records import ConsistencyGroupMetricsResponseRecords
from netapp_ontap.models.lun_vvol_bindings import LunVvolBindings
from netapp_ontap.models.fpolicy_engines import FpolicyEngines
from netapp_ontap.models.port_lag_active_ports import PortLagActivePorts
from netapp_ontap.models.cluster_nodes_ha_takeover import ClusterNodesHaTakeover
from netapp_ontap.models.san_application_components_tiering import SanApplicationComponentsTiering
from netapp_ontap.models.svm_migration_destination_volume_placement_volume_aggregate_pairs import SvmMigrationDestinationVolumePlacementVolumeAggregatePairs
from netapp_ontap.models.counter2d import Counter2d
from netapp_ontap.models.application_component_snapshot_svm import ApplicationComponentSnapshotSvm
from netapp_ontap.models.flexcache_atime_scrub import FlexcacheAtimeScrub
from netapp_ontap.models.igroup_initiator_no_records_proximity import IgroupInitiatorNoRecordsProximity
from netapp_ontap.models.oracle_on_nfs import OracleOnNfs
from netapp_ontap.models.top_metrics_svm_user_excluded_volume import TopMetricsSvmUserExcludedVolume
from netapp_ontap.models.aws_kms_key import AwsKmsKey
from netapp_ontap.models.cluster_nodes_service_processor_api_service import ClusterNodesServiceProcessorApiService
from netapp_ontap.models.shelf_bays_drawer import ShelfBaysDrawer
from netapp_ontap.models.shadowcopy_add_files import ShadowcopyAddFiles
from netapp_ontap.models.consistency_group_response_records_luns_lun_maps_igroup_initiators import ConsistencyGroupResponseRecordsLunsLunMapsIgroupInitiators
from netapp_ontap.models.fabric_connections_switch import FabricConnectionsSwitch
from netapp_ontap.models.cifs_open_file_share import CifsOpenFileShare
from netapp_ontap.models.security_proxy import SecurityProxy
from netapp_ontap.models.disk_drawer import DiskDrawer
from netapp_ontap.models.snapmirror_transfer_error_info import SnapmirrorTransferErrorInfo
from netapp_ontap.models.dr_pair import DrPair
from netapp_ontap.models.consistency_group_response_records_luns import ConsistencyGroupResponseRecordsLuns
from netapp_ontap.models.metrocluster_diagnostics_configreplication import MetroclusterDiagnosticsConfigreplication
from netapp_ontap.models.rfc2307_attribute import Rfc2307Attribute
from netapp_ontap.models.storage_pool_disk import StoragePoolDisk
from netapp_ontap.models.consistency_group_nvme_host_dh_hmac_chap import ConsistencyGroupNvmeHostDhHmacChap
from netapp_ontap.models.shelf_temperature_sensors_threshold_high import ShelfTemperatureSensorsThresholdHigh
from netapp_ontap.models.chassis_nodes_pcis import ChassisNodesPcis
from netapp_ontap.models.analytics_info import AnalyticsInfo
from netapp_ontap.models.reference_file_move_file import ReferenceFileMoveFile
from netapp_ontap.models.sql_on_san_new_igroups import SqlOnSanNewIgroups
from netapp_ontap.models.consistency_group_consistency_groups_luns import ConsistencyGroupConsistencyGroupsLuns
from netapp_ontap.models.network_route_for_svm import NetworkRouteForSvm
from netapp_ontap.models.shelf_ports_remote import ShelfPortsRemote
from netapp_ontap.models.fips import Fips
from netapp_ontap.models.application_lun_mapping_object_igroup import ApplicationLunMappingObjectIgroup
from netapp_ontap.models.svm_migration_messages import SvmMigrationMessages
from netapp_ontap.models.log_retention import LogRetention
from netapp_ontap.models.application_san_access_fcp_endpoint import ApplicationSanAccessFcpEndpoint
from netapp_ontap.models.aggregate_cloud_storage import AggregateCloudStorage
from netapp_ontap.models.ems_event_message import EmsEventMessage
from netapp_ontap.models.flexcache_guarantee import FlexcacheGuarantee
from netapp_ontap.models.lun_copy import LunCopy
from netapp_ontap.models.ip_interface_and_gateway import IpInterfaceAndGateway
from netapp_ontap.models.ip_info import IpInfo
from netapp_ontap.models.volume_aggregates import VolumeAggregates
from netapp_ontap.models.flexcache_prepopulate import FlexcachePrepopulate
from netapp_ontap.models.ipv6_interface import Ipv6Interface
from netapp_ontap.models.ip_address_range import IpAddressRange
from netapp_ontap.models.ldap_ip_status import LdapIpStatus
from netapp_ontap.models.aggregate_warning_action import AggregateWarningAction
from netapp_ontap.models.application_component_storage_service import ApplicationComponentStorageService
from netapp_ontap.models.cifs_domain_password_schedule import CifsDomainPasswordSchedule
from netapp_ontap.models.nvme_subsystem_io_queue import NvmeSubsystemIoQueue
from netapp_ontap.models.zapp_s3_bucket_application_components import ZappS3BucketApplicationComponents
from netapp_ontap.models.ldap_status import LdapStatus
from netapp_ontap.models.fc_port_transceiver import FcPortTransceiver
from netapp_ontap.models.cluster_metrics_response_records import ClusterMetricsResponseRecords
from netapp_ontap.models.s3_log_retention import S3LogRetention
from netapp_ontap.models.software_validation import SoftwareValidation
from netapp_ontap.models.raid_group import RaidGroup
from netapp_ontap.models.consistency_group_response_records import ConsistencyGroupResponseRecords
from netapp_ontap.models.onboard_key_manager_configurable_status import OnboardKeyManagerConfigurableStatus
from netapp_ontap.models.ems_filter_rules_message_criteria import EmsFilterRulesMessageCriteria
from netapp_ontap.models.health_monitor_policy_fields import HealthMonitorPolicyFields
from netapp_ontap.models.metrocluster_diag_check import MetroclusterDiagCheck
from netapp_ontap.models.consistency_group_lun_map_igroup_initiators import ConsistencyGroupLunMapIgroupInitiators
from netapp_ontap.models.fpolicy_event_file_operations import FpolicyEventFileOperations
from netapp_ontap.models.autosupport_issues import AutosupportIssues
from netapp_ontap.models.cluster_nodes_ha_takeover_check import ClusterNodesHaTakeoverCheck
from netapp_ontap.models.san_application_components import SanApplicationComponents
from netapp_ontap.models.software_update_details import SoftwareUpdateDetails
from netapp_ontap.models.nfs_service_protocol_access_rules import NfsServiceProtocolAccessRules
from netapp_ontap.models.cluster_peer_authentication import ClusterPeerAuthentication
from netapp_ontap.models.security_key_manager_external import SecurityKeyManagerExternal
from netapp_ontap.models.svm_migration_source import SvmMigrationSource
from netapp_ontap.models.fc_interface_svm import FcInterfaceSvm
from netapp_ontap.models.top_metrics_svm_directory_excluded_volume_reason import TopMetricsSvmDirectoryExcludedVolumeReason
from netapp_ontap.models.bgp_peer_group_local_ip import BgpPeerGroupLocalIp
from netapp_ontap.models.cluster_nodes_external_cache import ClusterNodesExternalCache
from netapp_ontap.models.anti_ransomware_volume_event_log import AntiRansomwareVolumeEventLog
from netapp_ontap.models.shelf_manufacturer import ShelfManufacturer
from netapp_ontap.models.token_node import TokenNode
from netapp_ontap.models.consistency_group_child import ConsistencyGroupChild
from netapp_ontap.models.file_info_constituent import FileInfoConstituent
from netapp_ontap.models.qos_policy_group import QosPolicyGroup
from netapp_ontap.models.application_cifs_properties_backing_storage import ApplicationCifsPropertiesBackingStorage
from netapp_ontap.models.consistency_group_igroup_igroups import ConsistencyGroupIgroupIgroups
from netapp_ontap.models.cluster_nodes_controller_frus import ClusterNodesControllerFrus
from netapp_ontap.models.software_status_details_reference_issue import SoftwareStatusDetailsReferenceIssue
from netapp_ontap.models.nfs_service_protocol_v42_features import NfsServiceProtocolV42Features
from netapp_ontap.models.fpolicy_events import FpolicyEvents
from netapp_ontap.models.igroup_initiator_connectivity_tracking_connections_logins_interface import IgroupInitiatorConnectivityTrackingConnectionsLoginsInterface
from netapp_ontap.models.qtree_group import QtreeGroup
from netapp_ontap.models.snapshot_provenance_volume import SnapshotProvenanceVolume
from netapp_ontap.models.storage_pool_patch import StoragePoolPatch
from netapp_ontap.models.flexcache_relative_size import FlexcacheRelativeSize
from netapp_ontap.models.port_statistics import PortStatistics
from netapp_ontap.models.nvme_interface_ip_interface import NvmeInterfaceIpInterface
from netapp_ontap.models.vdi_on_san_new_igroups import VdiOnSanNewIgroups
from netapp_ontap.models.related_link import RelatedLink
from netapp_ontap.models.consistency_group_response_records_replication_relationships import ConsistencyGroupResponseRecordsReplicationRelationships
from netapp_ontap.models.snapmirror_source_endpoint import SnapmirrorSourceEndpoint
from netapp_ontap.models.igroup_target import IgroupTarget
from netapp_ontap.models.switch_port_identity import SwitchPortIdentity
from netapp_ontap.models.volume_analytics import VolumeAnalytics
from netapp_ontap.models.lun_map_reporting_node_lun import LunMapReportingNodeLun
from netapp_ontap.models.cluster_nodes_service_processor_ssh_info import ClusterNodesServiceProcessorSshInfo
from netapp_ontap.models.counter_schema import CounterSchema
from netapp_ontap.models.switch_port_remote_port import SwitchPortRemotePort
from netapp_ontap.models.volume_protocol_raw_performance_stat_create import VolumeProtocolRawPerformanceStatCreate
from netapp_ontap.models.volume_flash_pool import VolumeFlashPool
from netapp_ontap.models.anti_ransomware_volume_workload_typical_usage import AntiRansomwareVolumeWorkloadTypicalUsage
from netapp_ontap.models.cluster_nodes_hw_assist_status import ClusterNodesHwAssistStatus
from netapp_ontap.models.policies_and_rules_to_be_applied_to_be_applied import PoliciesAndRulesToBeAppliedToBeApplied
from netapp_ontap.models.apply_to import ApplyTo
from netapp_ontap.models.port_reachable_broadcast_domains import PortReachableBroadcastDomains
from netapp_ontap.models.volume_rebalancing1_engine_scanner_blocks_skipped import VolumeRebalancing1EngineScannerBlocksSkipped
from netapp_ontap.models.port_statistics_device import PortStatisticsDevice
from netapp_ontap.models.storage_switch_connections_source_port import StorageSwitchConnectionsSourcePort
from netapp_ontap.models.fc_port_fabric import FcPortFabric
from netapp_ontap.models.analytics_info_by_accessed_time import AnalyticsInfoByAccessedTime
from netapp_ontap.models.consistency_group_clone import ConsistencyGroupClone
from netapp_ontap.models.ems_ui_message_arguments import EmsUiMessageArguments
from netapp_ontap.models.storage_pool_used_allocation_unit import StoragePoolUsedAllocationUnit
from netapp_ontap.models.capacity_pool_nodes import CapacityPoolNodes
from netapp_ontap.models.ipsec_policy_response_records import IpsecPolicyResponseRecords
from netapp_ontap.models.fc_switch_port import FcSwitchPort
from netapp_ontap.models.kerberos_realm_ad_server import KerberosRealmAdServer
from netapp_ontap.models.storage_switch_ports_sfp import StorageSwitchPortsSfp
from netapp_ontap.models.software_upload import SoftwareUpload
from netapp_ontap.models.lun_copy_destinations_progress import LunCopyDestinationsProgress
from netapp_ontap.models.aggregate_block_storage_primary import AggregateBlockStoragePrimary
from netapp_ontap.models.ems_destination_response_records_connectivity_errors import EmsDestinationResponseRecordsConnectivityErrors
from netapp_ontap.models.metrocluster_diag_details import MetroclusterDiagDetails
from netapp_ontap.models.lun_qos_policy import LunQosPolicy
from netapp_ontap.models.nvme_subsystem_map_namespace import NvmeSubsystemMapNamespace
from netapp_ontap.models.nvme_subsystem_subsystem_maps_namespace import NvmeSubsystemSubsystemMapsNamespace
from netapp_ontap.models.key_server_state_array import KeyServerStateArray
from netapp_ontap.models.cluster_nodes_ha_giveback import ClusterNodesHaGiveback
from netapp_ontap.models.snapmirror_destination_creation_tiering import SnapmirrorDestinationCreationTiering
from netapp_ontap.models.layout_requirement import LayoutRequirement
from netapp_ontap.models.aggregate_block_storage_hybrid_cache import AggregateBlockStorageHybridCache
from netapp_ontap.models.igroup_initiator_records import IgroupInitiatorRecords
from netapp_ontap.models.application_statistics_components_space import ApplicationStatisticsComponentsSpace
from netapp_ontap.models.performance_monitored_files_metric_response_records import PerformanceMonitoredFilesMetricResponseRecords
from netapp_ontap.models.security_association_ipsec_outbound import SecurityAssociationIpsecOutbound
from netapp_ontap.models.application_nfs_properties_export_policy import ApplicationNfsPropertiesExportPolicy
from netapp_ontap.models.nvme_service_statistics import NvmeServiceStatistics
from netapp_ontap.models.top_metrics_svm_client_response_notice import TopMetricsSvmClientResponseNotice
from netapp_ontap.models.consistency_group_lun_lun_maps_igroup_initiators import ConsistencyGroupLunLunMapsIgroupInitiators
from netapp_ontap.models.firmware_update_progress import FirmwareUpdateProgress
from netapp_ontap.models.qtree_statistics_raw import QtreeStatisticsRaw
from netapp_ontap.models.cifs_service_delete import CifsServiceDelete
from netapp_ontap.models.application_namespace_object import ApplicationNamespaceObject
from netapp_ontap.models.chassis_nodes_usbs import ChassisNodesUsbs
from netapp_ontap.models.consistency_group_replication_relationship import ConsistencyGroupReplicationRelationship
from netapp_ontap.models.job_node import JobNode
from netapp_ontap.models.lun_consistency_group import LunConsistencyGroup
from netapp_ontap.models.performance_svm_nfs_metric_historical_v3 import PerformanceSvmNfsMetricHistoricalV3
from netapp_ontap.models.lun_attributes import LunAttributes
from netapp_ontap.models.consistency_group_vdisk_provisioning_options import ConsistencyGroupVdiskProvisioningOptions
from netapp_ontap.models.performance_svm_nfs_metric_historical_v4 import PerformanceSvmNfsMetricHistoricalV4
from netapp_ontap.models.snaplock_log_archive import SnaplockLogArchive
from netapp_ontap.models.volume_error_state import VolumeErrorState
from netapp_ontap.models.shelf_acps_error import ShelfAcpsError
from netapp_ontap.models.ems_action_parameter_title_arguments import EmsActionParameterTitleArguments
from netapp_ontap.models.igroup_connectivity_tracking_required_nodes import IgroupConnectivityTrackingRequiredNodes
from netapp_ontap.models.iscsi_service_target import IscsiServiceTarget
from netapp_ontap.models.cluster_peer_local_network_interfaces import ClusterPeerLocalNetworkInterfaces
from netapp_ontap.models.cifs_netbios import CifsNetbios
from netapp_ontap.models.zapp_nvme_components_subsystem_hosts import ZappNvmeComponentsSubsystemHosts
from netapp_ontap.models.chassis_node import ChassisNode
from netapp_ontap.models.cifs_service_options import CifsServiceOptions
from netapp_ontap.models.disk_path_info import DiskPathInfo
from netapp_ontap.models.href import Href
from netapp_ontap.models.node_management_interfaces import NodeManagementInterfaces
from netapp_ontap.models.switch_port_statistics import SwitchPortStatistics
from netapp_ontap.models.storage_pool_capacity import StoragePoolCapacity
from netapp_ontap.models.quota_report_space import QuotaReportSpace
from netapp_ontap.models.zapp_s3_bucket_application_components_access_policies_conditions import ZappS3BucketApplicationComponentsAccessPoliciesConditions
from netapp_ontap.models.svm_dns import SvmDns
from netapp_ontap.models.lun_copy_source import LunCopySource
from netapp_ontap.models.software_errors import SoftwareErrors
from netapp_ontap.models.consistency_group_child_namespaces import ConsistencyGroupChildNamespaces
from netapp_ontap.models.consistency_group_response_records_luns_lun_maps_igroup_igroups import ConsistencyGroupResponseRecordsLunsLunMapsIgroupIgroups
from netapp_ontap.models.azure_key_vault_state import AzureKeyVaultState
from netapp_ontap.models.application_nfs_properties import ApplicationNfsProperties
from netapp_ontap.models.cluster_peer_remote import ClusterPeerRemote
from netapp_ontap.models.ems_action_parameter_help_arguments import EmsActionParameterHelpArguments
from netapp_ontap.models.azure_key_vault_ekmip_reachability import AzureKeyVaultEkmipReachability
from netapp_ontap.models.totp_post import TotpPost
from netapp_ontap.models.metrocluster_diagnostics_cluster import MetroclusterDiagnosticsCluster
from netapp_ontap.models.application_rpo_components_rpo import ApplicationRpoComponentsRpo
from netapp_ontap.models.lun_movement_progress import LunMovementProgress
from netapp_ontap.models.performance_svm_nfs_statistics import PerformanceSvmNfsStatistics
from netapp_ontap.models.consistency_group_namespace_subsystem_map import ConsistencyGroupNamespaceSubsystemMap
from netapp_ontap.models.mcc_node import MccNode
from netapp_ontap.models.ems_event_action_parameters_validation_error_message_arguments import EmsEventActionParametersValidationErrorMessageArguments
from netapp_ontap.models.cluster_space_block_storage import ClusterSpaceBlockStorage
from netapp_ontap.models.cluster_nodes_controller_failed_power_supply_message import ClusterNodesControllerFailedPowerSupplyMessage
from netapp_ontap.models.consistency_group_volume_snapshot import ConsistencyGroupVolumeSnapshot
from netapp_ontap.models.application_component_snapshot_restore import ApplicationComponentSnapshotRestore
from netapp_ontap.models.aggregate_spare import AggregateSpare
from netapp_ontap.models.binding_status import BindingStatus
from netapp_ontap.models.consistency_group_nvme_host import ConsistencyGroupNvmeHost
from netapp_ontap.models.gcp_kms_ekmip_reachability import GcpKmsEkmipReachability
from netapp_ontap.models.performance_svm_nfs_metric_historical import PerformanceSvmNfsMetricHistorical
from netapp_ontap.models.ems_destination_connectivity import EmsDestinationConnectivity
from netapp_ontap.models.disk_virtual import DiskVirtual
from netapp_ontap.models.nvme_subsystem_host_records import NvmeSubsystemHostRecords
from netapp_ontap.models.portset_interface_records import PortsetInterfaceRecords
from netapp_ontap.models.application_san_access import ApplicationSanAccess
from netapp_ontap.models.file_copy_files_to_copy import FileCopyFilesToCopy
from netapp_ontap.models.application_svm import ApplicationSvm
from netapp_ontap.models.performance_svm import PerformanceSvm
from netapp_ontap.models.application_san_access_iscsi_endpoint_interface_ip import ApplicationSanAccessIscsiEndpointInterfaceIp
from netapp_ontap.models.portset_interfaces import PortsetInterfaces
from netapp_ontap.models.firmware import Firmware
from netapp_ontap.models.vdi_on_nas_desktops_storage_service import VdiOnNasDesktopsStorageService
from netapp_ontap.models.anti_ransomware_volume_workload import AntiRansomwareVolumeWorkload
from netapp_ontap.models.storage_pool_show_spares import StoragePoolShowSpares
from netapp_ontap.models.license_package_licenses import LicensePackageLicenses
from netapp_ontap.models.s3_bucket_lifecycle_object_filter import S3BucketLifecycleObjectFilter
from netapp_ontap.models.svm_nsswitch import SvmNsswitch
from netapp_ontap.models.performance_fc_interface_metric_response_records import PerformanceFcInterfaceMetricResponseRecords
from netapp_ontap.models.cluster_nodes_ha_ports import ClusterNodesHaPorts
from netapp_ontap.models.consistency_group_igroup_initiators import ConsistencyGroupIgroupInitiators
from netapp_ontap.models.subject_alternate_name import SubjectAlternateName
from netapp_ontap.models.giveback_status import GivebackStatus
from netapp_ontap.models.cifs_target import CifsTarget
from netapp_ontap.models.volume_encryption_status import VolumeEncryptionStatus
from netapp_ontap.models.cluster_nodes_controller_failed_fan import ClusterNodesControllerFailedFan
from netapp_ontap.models.nvme_subsystem_controller_io_queue import NvmeSubsystemControllerIoQueue
from netapp_ontap.models.s3_service_post import S3ServicePost
from netapp_ontap.models.shelf_ports import ShelfPorts
from netapp_ontap.models.consistency_group_child_luns import ConsistencyGroupChildLuns
from netapp_ontap.models.ikp_kms_key import IkpKmsKey
from netapp_ontap.models.snapmirror_destination_creation import SnapmirrorDestinationCreation
from netapp_ontap.models.storage_port_error import StoragePortError
from netapp_ontap.models.lun_map_lun_smbc import LunMapLunSmbc
from netapp_ontap.models.ems_connectivity_error import EmsConnectivityError
from netapp_ontap.models.consistency_group_igroup import ConsistencyGroupIgroup
from netapp_ontap.models.file_info_qos_policy import FileInfoQosPolicy
from netapp_ontap.models.ipv4_interface import Ipv4Interface
from netapp_ontap.models.lun_convert_namespace import LunConvertNamespace
from netapp_ontap.models.port_metrics_response_records import PortMetricsResponseRecords
from netapp_ontap.models.shelf_frus_psu import ShelfFrusPsu
from netapp_ontap.models.nas_application_components_flexcache_origin_component import NasApplicationComponentsFlexcacheOriginComponent
from netapp_ontap.models.firmware_history_update_state_worker import FirmwareHistoryUpdateStateWorker
from netapp_ontap.models.consistency_group_statistics import ConsistencyGroupStatistics
from netapp_ontap.models.ems_syslog import EmsSyslog
from netapp_ontap.models.svm_migration_volume_errors import SvmMigrationVolumeErrors
from netapp_ontap.models.software_mcc import SoftwareMcc
from netapp_ontap.models.storage_switch_zones import StorageSwitchZones
from netapp_ontap.models.s3_log import S3Log
from netapp_ontap.models.ems_destination_response_records_filters import EmsDestinationResponseRecordsFilters
from netapp_ontap.models.consistency_group_response_records_consistency_groups_luns_lun_maps_igroup_initiators import ConsistencyGroupResponseRecordsConsistencyGroupsLunsLunMapsIgroupInitiators
from netapp_ontap.models.ems_event_action_parameters_help_arguments import EmsEventActionParametersHelpArguments
from netapp_ontap.models.shelf_acps import ShelfAcps
from netapp_ontap.models.aws_kms_state import AwsKmsState
from netapp_ontap.models.oracle_on_san import OracleOnSan
from netapp_ontap.models.oracle_on_nfs_archive_log import OracleOnNfsArchiveLog
from netapp_ontap.models.lun_attribute_lun import LunAttributeLun
from netapp_ontap.models.application_cifs_properties_server import ApplicationCifsPropertiesServer
from netapp_ontap.models.top_metrics_svm_user_iops import TopMetricsSvmUserIops
from netapp_ontap.models.volume_activity_tracking import VolumeActivityTracking
from netapp_ontap.models.cloud_store_unavailable_reason import CloudStoreUnavailableReason
from netapp_ontap.models.byte_lock import ByteLock
from netapp_ontap.models.cluster_space_cloud_storage import ClusterSpaceCloudStorage
from netapp_ontap.models.aggregate_block_storage_hybrid_cache_storage_pools import AggregateBlockStorageHybridCacheStoragePools
from netapp_ontap.models.consistency_group_response_records_consistency_groups import ConsistencyGroupResponseRecordsConsistencyGroups
from netapp_ontap.models.ip_interface_location import IpInterfaceLocation
from netapp_ontap.models.management_protocols import ManagementProtocols
from netapp_ontap.models.metrocluster_mccip_ports import MetroclusterMccipPorts
from netapp_ontap.models.oracle_on_nfs_ora_home_storage_service import OracleOnNfsOraHomeStorageService
from netapp_ontap.models.volume_constituents_space_logical_space import VolumeConstituentsSpaceLogicalSpace
from netapp_ontap.models.license_package_response_records_licenses import LicensePackageResponseRecordsLicenses
from netapp_ontap.models.volume_rebalancing1_engine import VolumeRebalancing1Engine
from netapp_ontap.models.application_subsystem_map_object import ApplicationSubsystemMapObject
from netapp_ontap.models.oracle_on_nfs_archive_log_storage_service import OracleOnNfsArchiveLogStorageService
from netapp_ontap.models.application_component_snapshot_restore_component import ApplicationComponentSnapshotRestoreComponent
from netapp_ontap.models.snapmirror_relationship_svmdr_volumes import SnapmirrorRelationshipSvmdrVolumes
from netapp_ontap.models.sql_on_san_db import SqlOnSanDb
from netapp_ontap.models.error import Error
from netapp_ontap.models.metrocluster_diagnostics_connection import MetroclusterDiagnosticsConnection
from netapp_ontap.models.volume_application import VolumeApplication
from netapp_ontap.models.igroup_lun_maps_lun import IgroupLunMapsLun
from netapp_ontap.models.consistency_group_nas import ConsistencyGroupNas
from netapp_ontap.models.flexcache_aggregates import FlexcacheAggregates
from netapp_ontap.models.aggregate_warning import AggregateWarning
from netapp_ontap.models.analytics_histogram_by_time import AnalyticsHistogramByTime
from netapp_ontap.models.consistency_group_nvme_subsystem import ConsistencyGroupNvmeSubsystem
from netapp_ontap.models.s3_group_users import S3GroupUsers
from netapp_ontap.models.application_component_snapshot_application import ApplicationComponentSnapshotApplication
from netapp_ontap.models.cluster_nodes_service_processor_web_service import ClusterNodesServiceProcessorWebService
from netapp_ontap.models.consistency_group_consistency_groups_restore_to_snapshot import ConsistencyGroupConsistencyGroupsRestoreToSnapshot
from netapp_ontap.models.volume_rebalancing import VolumeRebalancing
from netapp_ontap.models.sql_on_san_temp_db import SqlOnSanTempDb
from netapp_ontap.models.nvme_subsystem_host_no_records import NvmeSubsystemHostNoRecords
from netapp_ontap.models.san_new_igroups import SanNewIgroups
from netapp_ontap.models.security_oauth2_jwks import SecurityOauth2Jwks
from netapp_ontap.models.application_nvme_access import ApplicationNvmeAccess
from netapp_ontap.models.oracle_rac_on_san import OracleRacOnSan
from netapp_ontap.models.audit_events import AuditEvents
from netapp_ontap.models.storage_bridge_paths import StorageBridgePaths
from netapp_ontap.models.volume_efficiency_space_savings import VolumeEfficiencySpaceSavings
from netapp_ontap.models.volume_statistics_flexcache_raw import VolumeStatisticsFlexcacheRaw
from netapp_ontap.models.active_directory_discovered_servers import ActiveDirectoryDiscoveredServers
from netapp_ontap.models.interface_statistics import InterfaceStatistics
from netapp_ontap.models.consistency_group_lun_map_igroup_igroups import ConsistencyGroupLunMapIgroupIgroups
from netapp_ontap.models.zapp_nvme_components_subsystem import ZappNvmeComponentsSubsystem
from netapp_ontap.models.igroup_child import IgroupChild
from netapp_ontap.models.zapp_nvme_components import ZappNvmeComponents
from netapp_ontap.models.mongo_db_on_san_new_igroups_initiator_objects import MongoDbOnSanNewIgroupsInitiatorObjects
from netapp_ontap.models.top_metrics_svm_directory_excluded_volume import TopMetricsSvmDirectoryExcludedVolume
from netapp_ontap.models.igroup_lun_maps import IgroupLunMaps
from netapp_ontap.models.volume_files import VolumeFiles
from netapp_ontap.models.nas_application_components_snaplock_retention import NasApplicationComponentsSnaplockRetention
from netapp_ontap.models.fc_login_igroups import FcLoginIgroups
from netapp_ontap.models.metrocluster_interconnect_mirror import MetroclusterInterconnectMirror

__all__ = [
    "StorageSwitchFans",
    "AutoUpdateInfoEula",
    "StorageSwitchConnections",
    "VolumeSpace",
    "AzureKeyVaultConnectivity",
    "EmsFilterRuleResponseRecordsParameterCriteria",
    "TopMetricsDirectoryResponseIncompleteResponseReason",
    "SoftwareValidationReferenceIssue",
    "NfsServiceProtocol",
    "ClusterSpaceBlockStorageMedias",
    "ConsistencyGroupLunMap",
    "SnapmirrorPolicyRule",
    "ApplicationStatisticsIops",
    "PerformanceNvmeMetricProperties",
    "FcPortSpeed",
    "ZappNvmeComponentsPerformance",
    "VsiOnNas",
    "SvmMigrationDestinationVolumePlacementAggregates",
    "CifsOpenFileSession",
    "AclDelete",
    "DiskAggregates",
    "EmsEventLinks",
    "FileMoveScanner",
    "VsiOnNasDatastoreStorageService",
    "ConsistencyGroupResponseRecordsConsistencyGroupsLuns",
    "VolumeEfficiency",
    "LunStatus",
    "NvmeSubsystemHostRecordsSubsystem",
    "Version",
    "ActiveDirectoryPreferredDcs",
    "CapacityPoolResponseRecordsNodes",
    "AdDomainDelete",
    "KerberosRealmPasswordServer",
    "KeyServerState",
    "IgroupInitiatorsProximityPeerSvms",
    "SvmNis",
    "CapacityPoolNode",
    "ClusterNodesController",
    "ClusterNodesHaGivebackStatus",
    "FirmwareHistoryUpdateStateError",
    "NasExcludeAggregates",
    "NvmeInterfaceFcInterface",
    "FirmwareDisk",
    "OracleRacOnSanNewIgroups",
    "NvmeNamespaceSpaceGuarantee",
    "PortsetInterfaceNoRecords",
    "IgroupNestedNoRecords",
    "InterfaceMetricsData",
    "OracleOnNfsOraHome",
    "ApplicationLinks",
    "StorageSwitchPorts",
    "ConsistencyGroupResponseRecordsConsistencyGroupsVolumes",
    "FirmwareDqpRecordCount",
    "IgroupReplication",
    "LunLunMaps",
    "ConsistencyGroupApplication",
    "DiskErrorInfo",
    "FabricConnectionsClusterPort",
    "StorageBridgeSasPortsCable",
    "ApplicationNfsPropertiesPermissions",
    "IscsiConnectionInterface",
    "EkmipServerConnectivity",
    "NvmeSubsystemControllerDigest",
    "ConsistencyGroupLunLunMapsIgroupIgroups",
    "NodeSetupIp",
    "IgroupNestedIgroup",
    "OracleOnNfsRedoLogStorageService",
    "ConsistencyGroupReplicationRelationships1",
    "KerberosRealmAdminServer",
    "NvmeSubsystemHostRecordsIoQueue",
    "ConsistencyGroupLuns",
    "ConsistencyGroupLunsLunMapsIgroupInitiators",
    "IscsiConnectionInterfaceIp",
    "ActiveDirectoryDelete",
    "LocalCifsUserMembership",
    "StorageSwitchZonesPort",
    "SoftwareImagesInner",
    "FcpServiceTarget",
    "NvmeNamespaceSubsystemMap",
    "EmsActionParameter",
    "PlexResync",
    "TopMetricsFileIops",
    "Acl",
    "LunSpaceGuarantee",
    "ClusterNodesServiceProcessorAutoConfig",
    "SvmNfs",
    "TopMetricsClientIops",
    "TimezoneCluster",
    "LicenseCapacity",
    "StorageSwitchErrors",
    "ConsistencyGroupResponseRecordsConsistencyGroupsNamespaces",
    "S3BucketPolicy",
    "ReturnedError",
    "ConsistencyGroupNamespaceStatus",
    "MongoDbOnSanProtectionType",
    "ApplicationStatistics",
    "ConsistencyGroupChildLunsLunMaps",
    "QtreeNas",
    "VolumeConsistencyGroup",
    "CloudStorageTier",
    "ClusterNodesVm",
    "SwitchPortRemotePortDevice",
    "CifsDomainDiscoveredServer",
    "MetroclusterLocal",
    "ClusterPeerLinks",
    "DiskStats",
    "AntiRansomwareVolumeSpace",
    "EmsActionParameterDescriptionArguments",
    "HwAssistStatus",
    "QuotaReportSpaceUsed",
    "ZappNvmeRpoLocal",
    "NdmpScsi",
    "FirmwareShelf",
    "DiskKeyId",
    "Ipv4InterfaceAndGateway",
    "LicenseManagerResponseRecords",
    "ConsistencyGroupQos",
    "EmsEventResponseRecordsParameters",
    "ConsistencyGroupVolumeProvisioningOptions",
    "SoftwareStatusDetails",
    "ApplicationSanAccessIscsiEndpoint",
    "S3BucketSvmAggregates",
    "NodeResponseRecordsHaGivebackStatus",
    "ApplicationComponentSnapshotComponent",
    "ScheduleCluster",
    "ConsistencyGroupNamespace",
    "VscanOnDemandPolicy",
    "MongoDbOnSanNewIgroupsIgroups",
    "StorageBridgePathsTargetPort",
    "ConsistencyGroupConsistencyGroupsRestoreTo",
    "ApplicationRpoRemote",
    "ApplicationSnapshotComponents",
    "OracleRacOnSanDbSids",
    "ApplicationCifsPropertiesShare",
    "ApplicationCifsPropertiesPermissions",
    "LicenseCompliance",
    "BackupNode",
    "ConsistencyGroupResponseRecordsNamespaces",
    "NvmeSubsystemSubsystemMaps",
    "ShelfVoltageSensors",
    "KeyServerReadcreate",
    "MetroclusterInterconnectInterfaces",
    "VolumeMetricsResponseRecords",
    "S3BucketSvmProtectionStatus",
    "Tls",
    "ApplicationStatisticsComponentsIops",
    "NodeResponseRecordsHaGiveback",
    "VdiOnNas",
    "VolumeNas",
    "NvmeServiceMetric",
    "SecurityCertificateRefUuid",
    "SvmFcp",
    "EmsRoleConfigResponseRecords",
    "MultiAdminVerifyRuleApprovalGroups",
    "QuotaReportGroup",
    "SecurityAuditLogSvm",
    "FileMoveFilesToMove",
    "ApplicationLunMappingObject",
    "SvmMigrationVolumePlacementAggregates",
    "Nas",
    "ClusterNodesControllerCpu",
    "S3BucketPolicyStatement",
    "CifsDomainNameMapping",
    "ApplicationVolumeObject",
    "FpolicyEventFilters",
    "VolumeEfficiencyIdcsScanner",
    "NfsServiceWindows",
    "EmsEventActionParametersDescriptionArguments",
    "VolumeSpaceSnapshot",
    "AntiRansomwareSuspectFile",
    "PerformanceMetricIoTypeRwt",
    "ChassisNodes",
    "PerformanceFcPortMetricResponseRecords",
    "SvmNdmp",
    "ShelfTemperatureSensorsThresholdLow",
    "SqlOnSmb",
    "CifsDomainPreferredDcs",
    "AggregateBlockStorageMirror",
    "ClusterNodesClusterInterfaces",
    "S3PolicyStatement",
    "AuditSchedule",
    "SvmMigrationTimeMetrics",
    "FabricCache",
    "AccountApplication",
    "ApplicationNvmeAccessSubsystemMapSubsystemHostsLinks",
    "Peer",
    "MongoDbOnSanNewIgroups",
    "S3BucketLifecycleManagementRules",
    "Share",
    "KeyServerNoRecords",
    "QosPolicyAdaptive",
    "HwAssist",
    "WindowsToUnix",
    "AggregateSimulate",
    "NfsServiceCredentialCache",
    "NodeHaPartners",
    "TopMetricsSvmClientExcludedVolumeReason",
    "FirmwareDqp",
    "SnapmirrorConsistencyGroupFailoverStatus",
    "StorageBridgeFcPorts",
    "TapeDeviceStoragePort",
    "CounterProperty",
    "CifsConnectionSessions",
    "ConsistencyGroupResponseRecordsVolumes",
    "NodeStatistics",
    "S3BucketEncryption",
    "TopMetricsDirectoryResponseNotice",
    "MetroclusterDiagnosticsInterface",
    "CapacityPoolResponseRecords",
    "SnapmirrorError",
    "ApplicationRpoLocal",
    "ConsistencyGroupSpace",
    "FcZoneMembers",
    "InterfaceMetricsResponseRecords",
    "ConsistencyGroupExportPolicy",
    "FlexcacheWriteback",
    "QuotaRuleGroup",
    "VolumeProtocolRawPerformanceStatRw",
    "AwsKmsEkmipReachability",
    "LunMapLun",
    "ApplicationSanAccessBackingStorage",
    "ShareAcl",
    "ClusterNodesControllerFlashCache",
    "LunMovement",
    "SqlOnSmbAccess",
    "EmsEventUpdate",
    "QosPolicyFixed",
    "LunMapReportingNodesLinks",
    "ShelfTemperatureSensorsThreshold",
    "ConsistencyGroupLunsLunMapsIgroupIgroups",
    "ClusterNodesControllerFailedFanMessage",
    "FpolicyConnectionDisconnectedReason",
    "InstanceCounterAggregation",
    "PerformanceSvmNfsMetric",
    "EmsDestinationResponseRecordsConnectivityErrorsMessageArguments",
    "FabricConnectionsClusterPortNode",
    "MongoDbOnSanDatasetStorageService",
    "VsiOnNasDatastore",
    "IpInterfaceSvm",
    "EmsEventActionParametersTitleArguments",
    "StorageSwitchPaths",
    "NisServiceBindingDetails",
    "SvmMigrationIpInterfacePlacement",
    "StoragePoolSpareAllocationUnit",
    "ScannerPool",
    "ApplicationProtectionGroupsRpoRemote",
    "VolumeProtocolRawPerformanceStats",
    "PerformanceMetricReducedThroughput",
    "ApplicationStatisticsComponents",
    "NdmpData",
    "IgroupInitiatorListItemProximity",
    "AntiRansomwareVolume",
    "SvmAggregates",
    "EmsEventActionDescriptionArguments",
    "AdDomainSvm",
    "AggregateSnapshot",
    "PerformanceMonitoredFilesMetric",
    "ApplicationComponentApplication",
    "OracleRacOnNfs",
    "VolumeActivityTrackingUnsupportedReason",
    "CounterDenominator",
    "SecurityAssociationResponseRecords",
    "QuotaRuleUsers",
    "ConsistencyGroupQosPolicy",
    "EmsFilterResponseRecords",
    "GcpKmsKey",
    "VolumeRebalancing1EngineMovement",
    "ConsistencyGroupNamespaceSpaceGuarantee",
    "ExportRules",
    "FpolicyEngineSvm",
    "ConsistencyGroupVolumes",
    "VolumeAsynchronousDirectoryDelete",
    "AggregateSpace",
    "SnapshotSnaplock",
    "TopMetricsSvmFileExcludedVolume",
    "SnapshotPolicyCopies",
    "NvmeNamespaceStatus",
    "UnixGroupUsersNoRecords",
    "VolumeSpaceLogicalSpace",
    "ConsistencyGroupVolume",
    "IgroupInitiatorListItemProximityPeerSvms",
    "ApplicationNvmeAccessSubsystemMapSubsystem",
    "SnapmirrorConsistencyGroupFailover",
    "NvmeSubsystemControllerHost",
    "TopMetricsClientThroughput",
    "EmsEventActionParameters",
    "GroupPolicyObjectSecuritySetting",
    "ChassisNodesUsbsPorts",
    "IscsiConnection",
    "EmsDestinationResponseRecords",
    "MultiAdminVerifyRuleOwner",
    "QuotaRuleQtree",
    "S3BucketLifecycleExpiration",
    "IscsiCredentialsInitiatorAddress",
    "LunSpace",
    "SnapmirrorTransferFiles",
    "Nis",
    "PerformanceReducedThroughputResponseRecords",
    "FcInterfaceLocation",
    "MongoDbOnSan",
    "NvmeNamespaceLocation",
    "ShelfTemperatureSensors",
    "GroupPolicyObjectRestrictAnonymous",
    "PerformanceS3MetricResponseRecords",
    "StorageBridgeSasPorts",
    "ConsistencyGroupResponseRecordsLunsLunMaps",
    "ExportClients",
    "SoftwareNode",
    "ErrorResponses",
    "StorageBridgeErrors",
    "EmsEventParameter",
    "EmsDestinationConnectivityErrors",
    "QuotaReportFilesUsed",
    "FcInterfaceRecommendMessage",
    "RaidGroupRecomputingParity",
    "AntiRansomwareAttackReportLinks",
    "NasProtectionType",
    "SpaceEfficiency",
    "SelfLink",
    "EmsActionParameterValidationErrorMessageArguments",
    "EmsUiMessage",
    "IgroupInitiatorListItem",
    "ExportClientPolicy",
    "ClusterManagementInterfaces",
    "PerformanceMetricSvm",
    "IscsiCredentialsChap",
    "PerformanceLunMetricResponseRecords",
    "MetroclusterDiagnosticsNode",
    "NodeHa",
    "NasApplicationComponentsQosPolicy",
    "ZappS3Bucket",
    "AntiRansomwareVolumeWorkloadSurgeUsageNewlyObservedFileExtensions",
    "SnapmirrorRelationshipTransfer",
    "ConsistencyGroupNamespaces",
    "IgroupConnectivityTrackingAlerts",
    "SqlOnSan",
    "NvmeSubsystemControllerAdminQueue",
    "ConsistencyGroupInitiator",
    "ConsistencyGroupChildLunsLunMapsIgroupInitiators",
    "CifsDomainTrustRelationships",
    "LunMapReportingNodeIgroup",
    "Ddns",
    "PerformanceNvmeMetricResponseRecords",
    "ConsistencyGroupConsistencyGroupsApplication",
    "ApplicationProtectionGroupsRpo",
    "NodeResponseRecordsHa",
    "ConsistencyGroupConsistencyGroups",
    "ZappS3BucketApplicationComponentsAccessPolicies",
    "PerformanceMetricIoType",
    "LunLunMapsIgroup",
    "TopMetricsSvmDirectoryResponseNotice",
    "ApplicationComponentSnapshotRestoreApplication",
    "FileInfoLinks",
    "IgroupInitiatorNoRecords",
    "PortDiscoveredDevices",
    "ConsistencyGroupConsistencyGroupsTieringObjectStores",
    "QuotaReportUsers",
    "TopMetricsSvmUserVolumes",
    "RaidGroupReconstruct",
    "CifsShareAcls",
    "VolumeMetricCloud",
    "NasApplicationComponentsExportPolicy",
    "IscsiSessionIgroups",
    "ApplicationSnapshotRestoreApplication",
    "ZappNvmeRpoRemote",
    "NfsServiceProtocolV3Features",
    "ZappNvmeRpo",
    "KeyServerRecords",
    "ApplicationNvmeAccessSubsystemMapSubsystemHosts",
    "VolumeQuota",
    "AggregateWarningWarning",
    "AwsConnectivity",
    "ApplicationBackingStorage",
    "MccipPort",
    "NdmpConnect",
    "CifsDomainDiscoveredServers",
    "MetroclusterSvmPartnerSvm",
    "NvmeNamespaceSpace",
    "VolumeConstituentsAggregates",
    "VolumeConstituentsSpaceSnapshot",
    "EmsConnectivityErrorMessageArguments",
    "SvmMigrationCreate",
    "LunMovementPaths",
    "EmsDestinationConnectivityErrorsMessageArguments",
    "PortMetricsData",
    "FirmwareHistoryUpdateState",
    "EmsDestinationFilters",
    "IgroupNestedRecords",
    "PerformanceSvmNfsMetricHistoricalV41",
    "VolumeAnalyticsScanThrottleReason",
    "AntiRansomwareAttackReport",
    "GroupPolicyObjectRegistrySetting",
    "PortsetInterfacePortset",
    "SnaplockLogVolume",
    "IgroupInitiatorRecordsProximity",
    "VolumeSnaplockRetention",
    "Rfc2307bis",
    "S3BucketSvmLifecycleManagementRules",
    "ConsistencyGroupCifsShare",
    "S3BucketProtectionStatusDestination",
    "EmsFilterResponseRecordsRules",
    "NvmeInterfaceIpInterfaceLocation",
    "UnixGroupUsersUnixGroup",
    "NfsServiceTransport",
    "VolumeSpaceSnapshotAutodelete",
    "TopMetricsDirectoryIops",
    "S3BucketRetention",
    "VolumeSnapmirrorDestinations",
    "FlexcacheRelationship",
    "VolumeMetricFlexcache",
    "SplitLoadLoad",
    "ClusterNodesManagementInterfaces",
    "GcpConnectivity",
    "ConsistencyGroupIgroupChild",
    "VsiOnSan",
    "FabricConnections",
    "ApplicationCifsProperties",
    "NodeResponseRecordsClusterInterfaces",
    "ExportRulePolicy",
    "Rotation",
    "SqlOnSanDbStorageService",
    "VolumeAutosize",
    "VolumeConstituentsSpace",
    "ClusterNodesHa",
    "IgroupInitiators",
    "PoolHealth",
    "WebCsrfToken",
    "AzureKeyVaultKey",
    "NasApplicationComponentsFlexcache",
    "NdmpMover",
    "ClusterNodes",
    "PerformanceSvmResponseRecords",
    "NasApplicationComponents",
    "ConsistencyGroupLun",
    "DrNode",
    "EmsSyslogFormat",
    "S3BucketLifecycleAbortIncompleteMultipartUpload",
    "VolumeStatistics",
    "ClusterPeerStatus",
    "VolumeProtocolRawPerformanceStatOther",
    "EmsCertificate",
    "LocalCifsGroupMembers1",
    "NodeResponseRecords",
    "S3GroupPolicies",
    "AnalyticsInfoByModifiedTime",
    "FpolicyPolicies",
    "LicenseManagerUri",
    "SoftwareReferenceMetroclusterProgressDetails",
    "SvmMigrationIpInterfacePlacementIpInterfaces",
    "AggregateSpaceBlockStorage",
    "ApplicationRpoComponentsRpoRemote",
    "ConsistencyGroupConsistencyGroupsLunsCloneSource",
    "IscsiConnectionInitiatorAddress",
    "LunLocation",
    "FpolicyPersistentStores",
    "CloudTargetCluster",
    "VolumeConstituentsMovement",
    "IkpConnectivity",
    "ConsistencyGroupLunSpaceGuarantee",
    "TokenExpiryTime",
    "CifsDomainPreferredDcStatus",
    "ConsistencyGroupClone1Volume",
    "NfsServiceQtree",
    "UniformResourceIdentifier",
    "IgroupInitiatorProximityPeerSvms",
    "NodeResponseRecordsManagementInterfaces",
    "Rfc2307",
    "VolumeAnalyticsInitialization",
    "AggrSpaceEfficiency",
    "FileMoveFilesToMoveSources",
    "ShelfVendor",
    "AggregateInodeAttributes",
    "LicenseKeys",
    "SecurityAssociationIpsecInbound",
    "FpolicyEngineCertificate",
    "ApplicationRpo",
    "ClusterNodesManagementInterface",
    "GroupPolicyObjectRegistryValue",
    "NodeMetricsResponseRecords",
    "IgroupReplicationError",
    "SnaplockLitigationFileResponseRecords",
    "FcZoneMember",
    "IpInterfaceSvmIp",
    "PerformanceMetricResponseRecords",
    "KerberosRealmKdc",
    "Log",
    "OracleRacOnNfsGridBinary",
    "EmsParameterCriterion",
    "ApplicationStatisticsComponentsStorageService",
    "AnalyticsCollectionInfo",
    "ClusterNodesHaTakeoverFailure",
    "MongoDbOnSanSecondaryIgroups",
    "NodeClusterInterfaces",
    "ClusterPeerLocalNetwork",
    "TapeDeviceAlias",
    "VdiOnNasDesktops",
    "SecurityAssociationIke",
    "BgpPeerGroupPeer",
    "VolumeMovement",
    "TapeDevicePosition",
    "IgroupInitiatorConnectivityTrackingConnectionsLogins",
    "MetroclusterDrPairs",
    "SecurityKeyManagerRestoreKeys",
    "SvmS3Service",
    "TopMetricsDirectoryThroughput",
    "PerformanceFcpMetricSvm",
    "NvmeSubsystemHostIoQueue",
    "AnalyticsCollectionInfoByAccessedTimeBytesUsed",
    "BindingDetails",
    "ChassisNodesPcisCards",
    "EmsEventMessage1",
    "BgpPeerGroupLocalPortNode",
    "FirmwareUpdateProgressState",
    "NasApplicationComponentsFlexcacheOrigin",
    "MongoDbOnSanDataset",
    "BgpPeerGroupLocal",
    "AggregateBlockStorageHybridCacheSimulatedRaidGroups",
    "S3ServiceDelete",
    "ClusterNodesHaGivebackStatusError",
    "ApplicationStatisticsSpace",
    "MultiAdminVerifyApprovalGroupOwner",
    "StorageSwitchPathsAdapter",
    "BroadcastDomainPorts",
    "ReplicationErrorIgroup",
    "ErrorArguments",
    "EmsFilterRuleResponseRecords",
    "StorageSwitchVsans",
    "Entitlement",
    "ConsistencyGroupConsistencyGroupsLunsClone",
    "AppCifsAccess",
    "EmsEventAction",
    "LocalUserMembership",
    "EmsMessageResponseRecords",
    "NvmeInterfaceIpInterfaceIp",
    "ConsistencyGroupClone1Guarantee",
    "ConsistencyGroupProvisioningOptions",
    "ConsistencyGroupTiering",
    "TopMetricsClientResponseIncompleteResponseReason",
    "ConsistencyGroupConsistencyGroupsProvisioningOptionsStorageService",
    "SnaplockFileFingerprintGet",
    "S3BucketSvmLifecycleManagement",
    "PortLag",
    "FabricConnectionsSwitchPort",
    "StorageBridgeLastReboot",
    "VdiOnSan",
    "AppNfsAccess",
    "LunConvert",
    "ActiveDirectoryDiscoveredServer",
    "SvmMigrationDestination",
    "NasApplicationComponentsTiering",
    "ZappNvmeComponentsSubsystemHostsDhHmacChap",
    "OracleOnNfsRedoLog",
    "SqlOnSanLogStorageService",
    "StorageBridgePathsSourcePort",
    "KeyManagerState",
    "GroupPolicyObjectEventLog",
    "NvmeSubsystemIoQueueDefault",
    "VolumeEncryptionSupport",
    "NasApplicationComponentsQos",
    "EmsFilterRulesParameterCriteria",
    "LayoutRequirementRaidGroup",
    "VscanOnDemandScope",
    "Ipv6InterfaceAndGateway",
    "WebCertificate",
    "San",
    "IgroupInitiatorProximity",
    "ConsistencyGroupConsistencyGroupsVolumesNasJunctionParent",
    "NfsServiceProtocolV41Features",
    "LdapSchemaAccount",
    "S3ServicePostResponseRecords",
    "SqlOnSanTempDbStorageService",
    "SvmLdap",
    "AggregateSpaceCloudStorage",
    "CifsServiceSecurity",
    "ClusterNodesServiceProcessorBackup",
    "MetroclusterRemote",
    "TapeDeviceAliases",
    "StorageSwitchTemperatureSensors",
    "ClusterNodesClusterInterface",
    "VolumeEfficiencyScanner",
    "SecurityOauth2Introspection",
    "NvmeDhHmacChapAuthentication",
    "PerformanceNetworkMetrics",
    "StorageBridgePowerSupplyUnits",
    "AntiRansomwareVolumeSuspectFiles",
    "FabricZoneset",
    "NfsServiceExports",
    "ServiceProcessor",
    "IgroupInitiatorNoRecordsProximityPeerSvms",
    "VolumeTiering",
    "VsiOnSanNewIgroups",
    "VolumeNasJunctionParent",
    "NasApplicationComponentsStorageService",
    "PerformanceMetricRaw",
    "VolumeConstituents",
    "VolumeQos",
    "ClusterPeerInitialAllowedSvms",
    "ConsistencyGroupConsistencyGroupsLunsLunMapsIgroupIgroups",
    "FpolicyEngineResiliency",
    "VolumeGuarantee",
    "IgroupInitiatorsConnectivityTracking",
    "NodeHaGiveback",
    "ClusterNodesServiceProcessorPrimary",
    "FileMoveFile",
    "RaidGroupDisk",
    "NodeUuid",
    "PortVlan",
    "SoftwareReferenceMetroclusterProgressSummary",
    "AnalyticsCollectionInfoByAccessedTime",
    "SecuritySamlSpCertificate",
    "SnapmirrorRelationshipPolicy",
    "S3BucketLifecycleNonCurrentVersionExpiration",
    "UnixGroupUsersRecords",
    "ApplicationStatisticsComponentsLatency",
    "NvmeSubsystemHosts",
    "AdDomain",
    "OracleRacOnNfsOracleCrs",
    "QtreeUser",
    "StorageBridgeErrorsComponent",
    "VolumeRebalancing1EngineScanner",
    "ApplicationStatisticsLatency",
    "FlexcacheCifsChangeNotify",
    "ScopeIpspace",
    "TopMetricsClientResponseNotice",
    "S3ServerWarning",
    "S3BucketProtectionStatus",
    "VdiOnNasHyperVAccess",
    "SnapmirrorEndpoint",
    "SecurityKeystoreConfiguration",
    "EmsEventActionTitleArguments",
    "PerformanceIscsiMetricResponseRecords",
    "VolumeRebalancing1EngineScannerFilesSkipped",
    "PerformanceMetricRawReducedThroughput",
    "SqlOnSanLog",
    "IpInterfaceSvmLocation",
    "PerformanceCifsMetricResponseRecords",
    "ShelfPaths",
    "AutosupportConnectivityIssue",
    "ShelfPortsCable",
    "ConsistencyGroupChildLunsLunMapsIgroupIgroups",
    "SvmStorage",
    "LdapSchemaNameMapping",
    "ShelfFrus",
    "ConsistencyGroupResponseRecordsConsistencyGroupsLunsLunMaps",
    "S3BucketAggregates",
    "Cn",
    "ApplicationRpoComponentsRpoLocal",
    "ConsistencyGroupSnapshotResponseRecords",
    "S3UserPostPatch",
    "ApplicationRpoComponents",
    "IscsiCredentialsChapInbound",
    "NfsServiceProtocolV40Features",
    "CifsSessionVolumes",
    "SoftwareDataEncryption",
    "SvmMigrationIpInterfacePort",
    "VolumeEfficiencyPolicy1",
    "SwitchPortRemotePortDeviceShelf",
    "TopMetricsSvmClientExcludedVolume",
    "OracleRacOnNfsOracleCrsStorageService",
    "NetworkRouteInterfaces",
    "NodeHaGivebackStatus",
    "JobLink",
    "ClusterPeerEncryption",
    "FcInterfaceSvmLocation",
    "ConsistencyGroupConsistencyGroupsLunsLunMapsIgroupInitiators",
    "IgroupInitiatorConnectivityTracking",
    "SwitchMonitoring",
    "QuotaReportQtree",
    "FcSwitchPortsAttachedDevice",
    "PortsetIgroups",
    "SvmMigrationVolumeAggregatePair",
    "TopMetricValueErrorBounds",
    "ConsistencyGroupChildVolumes",
    "KeyManagerConfigHealthMonitorPolicy",
    "VolumeStatisticsCloud",
    "ShelfDrawers",
    "TopMetricsFileThroughput",
    "IgroupParent",
    "AutosupportMessageError",
    "ConsistencyGroupConsistencyGroupsNamespaces",
    "EmsFilterRuleParameterCriteria",
    "FcLoginInitiator",
    "TapeDeviceDeviceNames",
    "LunMapIgroup",
    "PreferredDcs",
    "SnaplockRetentionPolicyOperation",
    "IgroupConnectivityTracking",
    "ShelfErrors",
    "NasApplicationComponentsFlexcacheOriginSvm",
    "FcSwitchPorts",
    "FpolicyPoliciesScope",
    "MetroclusterDrGroupMccipPorts",
    "ClusterNisServiceBindingDetails",
    "VolumeRebalancing1EngineMovementLastError",
    "PerformanceSvmNfsResponseRecords",
    "SoftwareStatusDetailsReferenceNode",
    "NvmeSubsystemControllerInterface",
    "EmsDestinationResponseRecordsConnectivity",
    "CertificateSigningRequest",
    "StorageBridgeTemperatureSensor",
    "VolumeEncryption",
    "FileMoveFilesToMoveDestinations",
    "ApplicationTemplate1",
    "SoftwareReferenceMetrocluster",
    "S3AuditEvents",
    "NasApplicationComponentsTieringObjectStores",
    "ScheduleCron",
    "ClusterNodesMetroclusterPorts",
    "SvmIscsi",
    "ClusterManagementInterface",
    "NvmeSubsystemControllerDhHmacChap",
    "PerformanceMetricRawSvm",
    "AggregateBlockStoragePrimarySimulatedRaidGroups",
    "AutosupportConnectivityCorrectiveAction",
    "ConsistencyGroupCifsShareAcls",
    "LunMapReportingNodes",
    "ConsistencyGroupReplicationRelationships",
    "ApplicationProtectionGroups",
    "Posix",
    "NfsServiceRoot",
    "ShareLock",
    "SnapmirrorDestinationCreationStorageService",
    "ApplicationStatisticsComponentsSnapshot",
    "MetroclusterDiagConnectionDetails",
    "OracleRacOnNfsGridBinaryStorageService",
    "ConsistencyGroupResponseRecordsConsistencyGroupsLunsLunMapsIgroupIgroups",
    "ConsistencyGroupConsistencyGroupsVolumesNasCifs",
    "GroupPolicyObjectPrivilegeRight",
    "VolumeSnapmirror",
    "Counter",
    "PerformanceFcpMetricResponseRecords",
    "SecurityCertificateSign",
    "ClusterNodesMetrocluster",
    "GroupPolicyObjectKerberos",
    "QuotaRuleSpace",
    "ClusterNodesSnaplock",
    "VolumeSnaplock",
    "DiskOutage",
    "S3BucketLifecycleManagement",
    "ShelfCurrentSensors",
    "DeviceDiscoveryData",
    "SecurityAzure",
    "SvmSnapmirror",
    "SvmMigrationVolumePlacement",
    "EmsEventActionConfirmationMessageArguments",
    "StoragePortCable",
    "S3BucketSvmEncryption",
    "ZappNvme",
    "GroupPolicyObjectEventAudit",
    "SoftwareUpdateDetailsReferenceNode",
    "QuotaReportFiles",
    "SecurityKeyManagerOnboard",
    "PerformanceNamespaceMetricResponseRecords",
    "ClusterPeeringPolicy",
    "BroadcastDomainReferenceIpspace",
    "OracleOnNfsDb",
    "LunCopySourceProgress",
    "LunVvolBindingsPartner",
    "AnalyticsCollectionInfoByModifiedTimeBytesUsed",
    "GroupPolicyObjectBranchcache",
    "IgroupInitiatorsLinks",
    "ApplicationComponentSvm",
    "AntiRansomwareVolumeAttackDetectionParameters",
    "CifsOpenFileConnection",
    "VscanOnAccessScope",
    "LicensePackageResponseRecords",
    "SnapmirrorTransferRelationship",
    "SecurityKeyManagerExternalServerCaCertificates",
    "LocalCifsGroupMembersRecords",
    "ConsistencyGroupLunSpace",
    "OracleOnSanNewIgroups",
    "VolumeClone",
    "IpsecCaCertificateUuid",
    "Status",
    "Server",
    "NvmeNamespaceConvertLun",
    "SecurityAssociationIpsec",
    "ConsistencyGroupLunsLunMaps",
    "PerformanceReducedThroughput",
    "Smb",
    "FirmwareSpBmc",
    "EmsFilterResponseRecordsRulesParameterCriteria",
    "File",
    "IgroupInitiatorsProximity",
    "Member",
    "CifsAdDomain",
    "S3BucketSvmProtectionStatusDestination",
    "SnaplockLogFile",
    "MetroclusterDiagnosticsAggregate",
    "MetroclusterDiagConnection",
    "NvmeNamespaceClone",
    "PortLagMemberPorts",
    "UnixGroupUsers1",
    "Uri",
    "AggregateDataEncryption",
    "S3ServiceDeleteResponseRecords",
    "NasApplicationComponentsSnaplock",
    "AggregateSpaceSnapshot",
    "MccipPortL3Config",
    "SnapmirrorEndpointConsistencyGroupVolumes",
    "IgroupInitiatorRecordsProximityPeerSvms",
    "MediatorResponseRecords",
    "ApplicationProtectionGroupsRpoLocal",
    "SwitchSnmp",
    "ClusterNodesControllerFailedPowerSupply",
    "EmsEventResponseRecords",
    "QuotaRuleFiles",
    "S3AuditEventSelector",
    "AntiRansomwareVolumeWorkloadSurgeUsage",
    "ChassisFrus",
    "CloudStoreAggregate",
    "EmsEventParameters",
    "WebCsrf",
    "ConsistencyGroupConsistencyGroupsVolumes",
    "ShelfFans",
    "Usm",
    "IpsecEndpoint",
    "FcInterfaceResponseRecommend",
    "ZappS3BucketProtectionType",
    "S3ServiceUserPost",
    "LunMapLunNode",
    "StorageSwitchErrorsComponent",
    "SoftwarePackageDownloadGet",
    "AdvancedRights",
    "ClusterNodesHaInterconnect",
    "SvmMigrationVolumePlacementVolumeAggregatePairs",
    "ClusterNodesHaGivebackFailure",
    "MetroclusterDiagnosticsVolume",
    "SvmNvme",
    "ApplicationNvmeAccessBackingStorage",
    "SnapshotDelta",
    "EmsFilterRules",
    "StorageBridgeSasPortsPhy2",
    "StorageBridgeSasPortsPhy1",
    "StorageSwitchConnectionsPeerPort",
    "StorageBridgeSasPortsPhy4",
    "ConsistencyGroupVolumeSpace",
    "StorageBridgeSasPortsPhy3",
    "AggregateBlockStorage",
    "ConsistencyGroupLunLunMaps",
    "License",
    "FpolicyEngineBufferSize",
    "NfsServiceAccessCacheConfig",
    "ApplicationSnapshotApplication",
    "ShelfBays",
    "ApplicationSnapshotRestore",
    "ArwVserver",
    "IscsiCredentialsChapOutbound",
    "SoftwareStatusDetailsReferenceAction",
    "BroadcastDomainSvm",
    "ClusterNodesNvram",
    "SoftwareValidationReferenceAction",
    "LocalCifsGroupMembersNoRecords",
    "VolumeAnalyticsUnsupportedReason",
    "LunVvol",
    "NodeResponseRecordsHaPartners",
    "PortStatisticsPacketCounters",
    "CollectionLinks",
    "StorageBridgeFcPortsSfp",
    "LunCopyDestinations",
    "MetroclusterPartner",
    "ConsistencyGroupNamespaceSpace",
    "SvmCifsService",
    "IgroupInitiatorConnectivityTrackingConnections",
    "AnalyticsCollectionInfoByModifiedTime",
    "CifsDomainTrust",
    "StorageSwitchPathsPort",
    "IscsiSessionInitiator",
    "AggregateInactiveDataReporting",
    "ZappNvmeComponentsTiering",
    "NvmeNamespaceCloneSource",
    "ClusterNodesHaPartners",
    "NvmeNamespaceConvert",
    "ApplicationLunObject",
    "DetailedStatusCodeMessage",
    "S3BucketPolicyCondition",
    "VolumeEfficiencyPolicySchedule",
    "FcInterfaceLocationHomePortNode",
    "TopMetricsSvmUserThroughput",
    "GcpKmsState",
    "NfsServiceSecurity",
    "ConsistencyGroupConsistencyGroupsLunsLunMaps",
    "VolumeFlexgroup",
    "ConsistencyGroupMetricsResponseRecords",
    "LunVvolBindings",
    "FpolicyEngines",
    "PortLagActivePorts",
    "ClusterNodesHaTakeover",
    "SanApplicationComponentsTiering",
    "SvmMigrationDestinationVolumePlacementVolumeAggregatePairs",
    "Counter2d",
    "ApplicationComponentSnapshotSvm",
    "FlexcacheAtimeScrub",
    "IgroupInitiatorNoRecordsProximity",
    "OracleOnNfs",
    "TopMetricsSvmUserExcludedVolume",
    "AwsKmsKey",
    "ClusterNodesServiceProcessorApiService",
    "ShelfBaysDrawer",
    "ShadowcopyAddFiles",
    "ConsistencyGroupResponseRecordsLunsLunMapsIgroupInitiators",
    "FabricConnectionsSwitch",
    "CifsOpenFileShare",
    "SecurityProxy",
    "DiskDrawer",
    "SnapmirrorTransferErrorInfo",
    "DrPair",
    "ConsistencyGroupResponseRecordsLuns",
    "MetroclusterDiagnosticsConfigreplication",
    "Rfc2307Attribute",
    "StoragePoolDisk",
    "ConsistencyGroupNvmeHostDhHmacChap",
    "ShelfTemperatureSensorsThresholdHigh",
    "ChassisNodesPcis",
    "AnalyticsInfo",
    "ReferenceFileMoveFile",
    "SqlOnSanNewIgroups",
    "ConsistencyGroupConsistencyGroupsLuns",
    "NetworkRouteForSvm",
    "ShelfPortsRemote",
    "Fips",
    "ApplicationLunMappingObjectIgroup",
    "SvmMigrationMessages",
    "LogRetention",
    "ApplicationSanAccessFcpEndpoint",
    "AggregateCloudStorage",
    "EmsEventMessage",
    "FlexcacheGuarantee",
    "LunCopy",
    "IpInterfaceAndGateway",
    "IpInfo",
    "VolumeAggregates",
    "FlexcachePrepopulate",
    "Ipv6Interface",
    "IpAddressRange",
    "LdapIpStatus",
    "AggregateWarningAction",
    "ApplicationComponentStorageService",
    "CifsDomainPasswordSchedule",
    "NvmeSubsystemIoQueue",
    "ZappS3BucketApplicationComponents",
    "LdapStatus",
    "FcPortTransceiver",
    "ClusterMetricsResponseRecords",
    "S3LogRetention",
    "SoftwareValidation",
    "RaidGroup",
    "ConsistencyGroupResponseRecords",
    "OnboardKeyManagerConfigurableStatus",
    "EmsFilterRulesMessageCriteria",
    "HealthMonitorPolicyFields",
    "MetroclusterDiagCheck",
    "ConsistencyGroupLunMapIgroupInitiators",
    "FpolicyEventFileOperations",
    "AutosupportIssues",
    "ClusterNodesHaTakeoverCheck",
    "SanApplicationComponents",
    "SoftwareUpdateDetails",
    "NfsServiceProtocolAccessRules",
    "ClusterPeerAuthentication",
    "SecurityKeyManagerExternal",
    "SvmMigrationSource",
    "FcInterfaceSvm",
    "TopMetricsSvmDirectoryExcludedVolumeReason",
    "BgpPeerGroupLocalIp",
    "ClusterNodesExternalCache",
    "AntiRansomwareVolumeEventLog",
    "ShelfManufacturer",
    "TokenNode",
    "ConsistencyGroupChild",
    "FileInfoConstituent",
    "QosPolicyGroup",
    "ApplicationCifsPropertiesBackingStorage",
    "ConsistencyGroupIgroupIgroups",
    "ClusterNodesControllerFrus",
    "SoftwareStatusDetailsReferenceIssue",
    "NfsServiceProtocolV42Features",
    "FpolicyEvents",
    "IgroupInitiatorConnectivityTrackingConnectionsLoginsInterface",
    "QtreeGroup",
    "SnapshotProvenanceVolume",
    "StoragePoolPatch",
    "FlexcacheRelativeSize",
    "PortStatistics",
    "NvmeInterfaceIpInterface",
    "VdiOnSanNewIgroups",
    "RelatedLink",
    "ConsistencyGroupResponseRecordsReplicationRelationships",
    "SnapmirrorSourceEndpoint",
    "IgroupTarget",
    "SwitchPortIdentity",
    "VolumeAnalytics",
    "LunMapReportingNodeLun",
    "ClusterNodesServiceProcessorSshInfo",
    "CounterSchema",
    "SwitchPortRemotePort",
    "VolumeProtocolRawPerformanceStatCreate",
    "VolumeFlashPool",
    "AntiRansomwareVolumeWorkloadTypicalUsage",
    "ClusterNodesHwAssistStatus",
    "PoliciesAndRulesToBeAppliedToBeApplied",
    "ApplyTo",
    "PortReachableBroadcastDomains",
    "VolumeRebalancing1EngineScannerBlocksSkipped",
    "PortStatisticsDevice",
    "StorageSwitchConnectionsSourcePort",
    "FcPortFabric",
    "AnalyticsInfoByAccessedTime",
    "ConsistencyGroupClone",
    "EmsUiMessageArguments",
    "StoragePoolUsedAllocationUnit",
    "CapacityPoolNodes",
    "IpsecPolicyResponseRecords",
    "FcSwitchPort",
    "KerberosRealmAdServer",
    "StorageSwitchPortsSfp",
    "SoftwareUpload",
    "LunCopyDestinationsProgress",
    "AggregateBlockStoragePrimary",
    "EmsDestinationResponseRecordsConnectivityErrors",
    "MetroclusterDiagDetails",
    "LunQosPolicy",
    "NvmeSubsystemMapNamespace",
    "NvmeSubsystemSubsystemMapsNamespace",
    "KeyServerStateArray",
    "ClusterNodesHaGiveback",
    "SnapmirrorDestinationCreationTiering",
    "LayoutRequirement",
    "AggregateBlockStorageHybridCache",
    "IgroupInitiatorRecords",
    "ApplicationStatisticsComponentsSpace",
    "PerformanceMonitoredFilesMetricResponseRecords",
    "SecurityAssociationIpsecOutbound",
    "ApplicationNfsPropertiesExportPolicy",
    "NvmeServiceStatistics",
    "TopMetricsSvmClientResponseNotice",
    "ConsistencyGroupLunLunMapsIgroupInitiators",
    "FirmwareUpdateProgress",
    "QtreeStatisticsRaw",
    "CifsServiceDelete",
    "ApplicationNamespaceObject",
    "ChassisNodesUsbs",
    "ConsistencyGroupReplicationRelationship",
    "JobNode",
    "LunConsistencyGroup",
    "PerformanceSvmNfsMetricHistoricalV3",
    "LunAttributes",
    "ConsistencyGroupVdiskProvisioningOptions",
    "PerformanceSvmNfsMetricHistoricalV4",
    "SnaplockLogArchive",
    "VolumeErrorState",
    "ShelfAcpsError",
    "EmsActionParameterTitleArguments",
    "IgroupConnectivityTrackingRequiredNodes",
    "IscsiServiceTarget",
    "ClusterPeerLocalNetworkInterfaces",
    "CifsNetbios",
    "ZappNvmeComponentsSubsystemHosts",
    "ChassisNode",
    "CifsServiceOptions",
    "DiskPathInfo",
    "Href",
    "NodeManagementInterfaces",
    "SwitchPortStatistics",
    "StoragePoolCapacity",
    "QuotaReportSpace",
    "ZappS3BucketApplicationComponentsAccessPoliciesConditions",
    "SvmDns",
    "LunCopySource",
    "SoftwareErrors",
    "ConsistencyGroupChildNamespaces",
    "ConsistencyGroupResponseRecordsLunsLunMapsIgroupIgroups",
    "AzureKeyVaultState",
    "ApplicationNfsProperties",
    "ClusterPeerRemote",
    "EmsActionParameterHelpArguments",
    "AzureKeyVaultEkmipReachability",
    "TotpPost",
    "MetroclusterDiagnosticsCluster",
    "ApplicationRpoComponentsRpo",
    "LunMovementProgress",
    "PerformanceSvmNfsStatistics",
    "ConsistencyGroupNamespaceSubsystemMap",
    "MccNode",
    "EmsEventActionParametersValidationErrorMessageArguments",
    "ClusterSpaceBlockStorage",
    "ClusterNodesControllerFailedPowerSupplyMessage",
    "ConsistencyGroupVolumeSnapshot",
    "ApplicationComponentSnapshotRestore",
    "AggregateSpare",
    "BindingStatus",
    "ConsistencyGroupNvmeHost",
    "GcpKmsEkmipReachability",
    "PerformanceSvmNfsMetricHistorical",
    "EmsDestinationConnectivity",
    "DiskVirtual",
    "NvmeSubsystemHostRecords",
    "PortsetInterfaceRecords",
    "ApplicationSanAccess",
    "FileCopyFilesToCopy",
    "ApplicationSvm",
    "PerformanceSvm",
    "ApplicationSanAccessIscsiEndpointInterfaceIp",
    "PortsetInterfaces",
    "Firmware",
    "VdiOnNasDesktopsStorageService",
    "AntiRansomwareVolumeWorkload",
    "StoragePoolShowSpares",
    "LicensePackageLicenses",
    "S3BucketLifecycleObjectFilter",
    "SvmNsswitch",
    "PerformanceFcInterfaceMetricResponseRecords",
    "ClusterNodesHaPorts",
    "ConsistencyGroupIgroupInitiators",
    "SubjectAlternateName",
    "GivebackStatus",
    "CifsTarget",
    "VolumeEncryptionStatus",
    "ClusterNodesControllerFailedFan",
    "NvmeSubsystemControllerIoQueue",
    "S3ServicePost",
    "ShelfPorts",
    "ConsistencyGroupChildLuns",
    "IkpKmsKey",
    "SnapmirrorDestinationCreation",
    "StoragePortError",
    "LunMapLunSmbc",
    "EmsConnectivityError",
    "ConsistencyGroupIgroup",
    "FileInfoQosPolicy",
    "Ipv4Interface",
    "LunConvertNamespace",
    "PortMetricsResponseRecords",
    "ShelfFrusPsu",
    "NasApplicationComponentsFlexcacheOriginComponent",
    "FirmwareHistoryUpdateStateWorker",
    "ConsistencyGroupStatistics",
    "EmsSyslog",
    "SvmMigrationVolumeErrors",
    "SoftwareMcc",
    "StorageSwitchZones",
    "S3Log",
    "EmsDestinationResponseRecordsFilters",
    "ConsistencyGroupResponseRecordsConsistencyGroupsLunsLunMapsIgroupInitiators",
    "EmsEventActionParametersHelpArguments",
    "ShelfAcps",
    "AwsKmsState",
    "OracleOnSan",
    "OracleOnNfsArchiveLog",
    "LunAttributeLun",
    "ApplicationCifsPropertiesServer",
    "TopMetricsSvmUserIops",
    "VolumeActivityTracking",
    "CloudStoreUnavailableReason",
    "ByteLock",
    "ClusterSpaceCloudStorage",
    "AggregateBlockStorageHybridCacheStoragePools",
    "ConsistencyGroupResponseRecordsConsistencyGroups",
    "IpInterfaceLocation",
    "ManagementProtocols",
    "MetroclusterMccipPorts",
    "OracleOnNfsOraHomeStorageService",
    "VolumeConstituentsSpaceLogicalSpace",
    "LicensePackageResponseRecordsLicenses",
    "VolumeRebalancing1Engine",
    "ApplicationSubsystemMapObject",
    "OracleOnNfsArchiveLogStorageService",
    "ApplicationComponentSnapshotRestoreComponent",
    "SnapmirrorRelationshipSvmdrVolumes",
    "SqlOnSanDb",
    "Error",
    "MetroclusterDiagnosticsConnection",
    "VolumeApplication",
    "IgroupLunMapsLun",
    "ConsistencyGroupNas",
    "FlexcacheAggregates",
    "AggregateWarning",
    "AnalyticsHistogramByTime",
    "ConsistencyGroupNvmeSubsystem",
    "S3GroupUsers",
    "ApplicationComponentSnapshotApplication",
    "ClusterNodesServiceProcessorWebService",
    "ConsistencyGroupConsistencyGroupsRestoreToSnapshot",
    "VolumeRebalancing",
    "SqlOnSanTempDb",
    "NvmeSubsystemHostNoRecords",
    "SanNewIgroups",
    "SecurityOauth2Jwks",
    "ApplicationNvmeAccess",
    "OracleRacOnSan",
    "AuditEvents",
    "StorageBridgePaths",
    "VolumeEfficiencySpaceSavings",
    "VolumeStatisticsFlexcacheRaw",
    "ActiveDirectoryDiscoveredServers",
    "InterfaceStatistics",
    "ConsistencyGroupLunMapIgroupIgroups",
    "ZappNvmeComponentsSubsystem",
    "IgroupChild",
    "ZappNvmeComponents",
    "MongoDbOnSanNewIgroupsInitiatorObjects",
    "TopMetricsSvmDirectoryExcludedVolume",
    "IgroupLunMaps",
    "VolumeFiles",
    "NasApplicationComponentsSnaplockRetention",
    "FcLoginIgroups",
    "MetroclusterInterconnectMirror",
]
